Option Strict Off
Option Explicit On
Module Module_PP_5AX
    ' version du 19/09/2013  21h50
	
	Const Smini As Integer = 10
	Const Smaxi As Integer = 20000
	
	Const Fmini As Integer = 1
	Const Fmaxi As Integer = 10000
	
	
	Const debutligne1 As String = " G0 G40 G49 G80 G90 M9"
	Const debutligne2 As String = " G52 X0. Y0. Z0."
	Const debutligne3 As String = " (------------)"
	
	Const retourChangtOutil As String = " G53 G90 G0 Z0. H0"
	
	Const finligne1 As String = " G53 G90 G0 Z0. H0"
	Const finligne2 As String = " M5"
	Const finligne3 As String = " G53 G90 G0 X0. Y0."
	Const finligne4 As String = " M30"
	
	Const cstarr0 As String = " M9"
	Const cstarr1 As String = " M8"
	Const cstarr2 As String = " M7"
	Const cstarr3 As String = " (CODE ARROSAGE NON DEFINI)"
	Const cstarr4 As String = " (CODE ARROSAGE NON DEFINI)"
	
	Const cstn As String = "N"
	
	Const cg0 As String = " G0"
	Const cg1 As String = " G1"
	Const cg2 As String = " G2"
	Const cg3 As String = " G3"
	
	Const cstx As String = " X"
	Const csty As String = " Y"
	Const cstz As String = " Z"
	
	Const csti As String = " I"
	Const cstj As String = " J"
	
	Const csta As String = " A"
	Const cstc As String = " C"
	
	Const cstp As String = " P"
	Const cstq As String = " Q"
	Const cst_r As String = " R"
	
	Const caunclamp As String = " M79"
	Const caclamp As String = " M78"
	Const ccunclamp As String = " M11"
	Const ccclamp As String = " M10"
	
	Const cg90 As String = " G90"
	
	Const cg52 As String = " G52"
	Const cg53 As String = " G53"
	Const cg54 As String = " G54"
	Const cg55 As String = " G55"
	Const cg56 As String = " G56"
	Const cg57 As String = " G57"
	Const cg58 As String = " G58"
	Const cg59 As String = " G59"
	Const cg541p As String = " G54.1 P"
	
	Const cstt As String = " T"
	Const cm0 As String = " M0"
	Const cm1 As String = " M1"
	Const cm6 As String = " M6"
	Const cvitesse As String = " S"
	Const cm3 As String = " M3"
	Const cm4 As String = " M4"
	Const cm5 As String = " M5"
	Const cm51 As String = " M51"
	Const cm68 As String = " M68"
	
	Const cavance As String = " F"
	Const cg94 As String = " G94"
	Const cg93 As String = " G93"
	
	Const cg43 As String = " G43"
	Const cg434 As String = " G43.4"
	Const cg49 As String = " G49"
	Const csth As String = " H"
	
	Const cg41 As String = " G41"
	Const cg42 As String = " G42"
	Const cg40 As String = " G40"
	Const cstd As String = " D"
	
	Const cg682 As String = " G68.2"
	Const cg69 As String = " G69"
	Const cg531 As String = " G53.1"
	
	Const cg80 As String = " G80"
	Const cg73 As String = " G73"
	Const cg74 As String = " G74"
	Const cg76 As String = " G76"
	Const cg81 As String = " G81"
	Const cg82 As String = " G82"
	Const cg83 As String = " G83"
	Const cm29s As String = ""
	Const cg84 As String = " G84"
	Const cg85 As String = " G85"
	Const cg86 As String = " G86"
	Const cg87 As String = " G87"
	Const cg88 As String = " G88"
	Const cg89 As String = " G89"
	
	Const cg98 As String = " G98"
	Const cg99 As String = " G99"
	
	Const cg51q0 As String = " G5.1 Q0"
	Const cg51q1r As String = " G5.1 Q1 R"
	
	Const cstFinSP As String = " M99" & vbLf & "%"
	Const cstFinProg As String = " M99" & vbLf & "%"
	
	Const pi As Double = 3.14159265358979
	
	
	
	
	
    Structure pointdebut
        Dim x As Double
        Dim y As Double
        Dim z As Double
        Dim i As Double
        Dim j As Double
        Dim k As Double
    End Structure



    Structure pointfinal
        Dim ax As Double
        Dim bx As Double
        Dim cx As Double
        Dim dx As Double
        Dim ex As Double
    End Structure

    Structure pointfinalcercle
        Dim debut As pointfinal
        Dim fin As pointfinal
        Dim axc As Double
        Dim bxc As Double
        Dim ix As Double
        Dim jx As Double
        Dim g As Double
        Dim ac As Double
        Dim pas As Double
        Dim bc As Double
        Dim at As Double
    End Structure


    Structure outilclass
        Dim tc As Double
        Dim ts As Double
        Dim dia As Double
        Dim s As Double
        Dim rot As Double
        Dim arr As Double
        Dim code_arr() As String
        Dim f As Double
        Dim Forigin As Double
        Dim couple As Double
        Dim h As Double
        Dim corrh As Double
        Dim d As Double
        Dim corrd As Double

        Public Sub Initialize()
            ReDim code_arr(10)
        End Sub

    End Structure

    Structure cycleclass
        Dim Za As Double
        Dim Zaf As Double
        Dim Zp As Double
        Dim Zr As Double
        Dim Q As Double
        Dim P As Double
        Dim Gs As Double
    End Structure



    Structure varclass
        Dim rota(,) As Double
        Dim rotb(,) As Double
        Dim rotetat As Short
        Dim ptd As pointdebut
        Dim ptf As pointfinal
        Dim ptfa As pointfinal
        Dim ptc As pointfinalcercle
        Dim ga As Double
        Dim gb As Double
        Dim gc As Double
        Dim gd As Double
        Dim ge As Double
        Dim gz As Double
        Dim m As Double
        Dim outil As outilclass
        Dim cycle As cycleclass
        Dim sortie As String
        Dim px As Double
        Dim py As Double
        Dim pz As Double
        Dim cldx As Short
        Dim clex As Short
        Dim xdec As Double
        Dim ydec As Double
        Dim zdec As Double
        Dim plunge As Double
        Dim Zplunge As Double
        Dim rotdx As Double
        Dim rotex As Double
        Dim defaultex As Double
        Dim finvers As Short
        Dim g682x As Double
        Dim g682y As Double
        Dim g682z As Double
        Dim g682m As Double
        Dim g682auto As Double
        Dim g434etat As Short
        Dim lintol As Double
        Dim high As Short
        Dim high_etat As Short
        Dim etat As Short

        Public Sub Initialize()
            ReDim rota(3, 4)
            ReDim rotb(3, 4)
            outil.Initialize()
        End Sub

    End Structure







    Structure sortieclass
        Dim imanew1 As varclass
        Dim imaold1 As varclass
        Dim Erreur As String
        Dim chaine As String
        Dim cetat As Short

        Public Sub Initialize()
            imanew1.Initialize()
            imaold1.Initialize()
        End Sub
    End Structure




    Public newvar As varclass
    Public oldvar As varclass
    Public sortie As sortieclass


    Public ptindirv As pointfinal
    Public ptd As pointdebut
    Public ptf As pointfinal
    Public cercle As pointfinalcercle
    Public ptfa As pointfinal

    Public path As String
    Public numeroBloc As Integer
    Public increment As Short

    Public buffer As String






    Function numN() As String

        If numeroBloc = -1 Then
            numN = ""
        Else
            numeroBloc = numeroBloc + increment
            numN = cstn & Mid(Str(numeroBloc), 2)
        End If

    End Function





    Function PresenceFichier(ByRef varNomFichier As String) As Boolean

        Dim objFSO As Object

        objFSO = CreateObject("Scripting.FileSystemObject")
        If (objFSO.FileExists(varNomFichier)) Then
            PresenceFichier = True
        Else
            PresenceFichier = False
        End If
        objFSO = Nothing

    End Function







    Sub pp5axes(ByVal urlaptsource As String)

        Dim f As Object
        Dim fs As Object
        Dim passage As Double
        Dim boucle As Double


        newvar.Initialize()
        oldvar.Initialize()
        sortie.Initialize()

        newvar.ptf.ex = 15
        oldvar.ptf.ex = 10


        pp_saisie.Label1.Text = "debut traitement"
        System.Windows.Forms.Application.DoEvents()


        Dim ch0 As String
        Dim path As String
        path = ""
        Dim nom_de_fichier As String



        ch0 = urlaptsource

        Do While InStr(ch0, Chr(92)) > 0

            path = path & Mid(ch0, 1, InStr(ch0, Chr(92)))
            ch0 = Mid(ch0, InStr(ch0, Chr(92)) + 1)

        Loop


        nom_de_fichier = Mid(ch0, 1, InStr(ch0, ".") - 1)


        Dim fichier_sortie As String

        Dim fichier_sortie_principal As String
        fichier_sortie_principal = ""


        Dim fichier_sortie_etat As Short
        fichier_sortie_etat = -1



        Dim fichier_sortie2 As Short
        fichier_sortie2 = FreeFile()


        numeroBloc = 5
        increment = 5

        newvar.rotetat = 0


        Dim i As Short
        Dim j As Short

        For i = 0 To 3
            For j = 0 To 4
                newvar.rota(i, j) = 0
                newvar.rotb(i, j) = 0
            Next j
        Next i

        newvar.rota(1, 1) = 1
        newvar.rota(2, 2) = 1
        newvar.rota(3, 3) = 1

        newvar.rotb(1, 1) = 1
        newvar.rotb(2, 2) = 1
        newvar.rotb(3, 3) = 1





        oldvar.ga = 1.0E+100
        oldvar.gb = 1.0E+100
        oldvar.gc = 1.0E+100
        oldvar.ge = 9999
        oldvar.ptf.ax = 1.0E+100
        oldvar.ptf.bx = 1.0E+100
        oldvar.ptf.cx = 1.0E+100
        oldvar.ptf.dx = 1.0E+100
        oldvar.ptf.ex = 0
        oldvar.outil.tc = 1.0E+100
        oldvar.outil.arr = 0
        oldvar.outil.s = 1.0E+100
        oldvar.outil.rot = 1.0E+100
        oldvar.outil.corrd = 40
        oldvar.cycle.Zaf = 1.0E+100
        oldvar.ptc.ac = 1.0E+100
        oldvar.ptc.bc = 1.0E+100
        oldvar.ptc.at = 0
        oldvar.cycle.Gs = 1.0E+100
        oldvar.plunge = 0
        oldvar.cldx = 1
        oldvar.clex = 1
        oldvar.g682m = 69

        newvar.px = 0
        newvar.py = 0
        newvar.pz = 0

        newvar.ga = 1.0E+100
        newvar.gb = 54
        newvar.gc = 90
        newvar.ge = 94
        newvar.ptf.dx = 0
        newvar.ptf.ex = 0
        newvar.outil.arr = 0
        newvar.outil.code_arr(0) = cstarr0
        newvar.outil.code_arr(1) = cstarr1
        newvar.outil.code_arr(2) = cstarr2
        newvar.outil.code_arr(3) = cstarr3
        newvar.outil.code_arr(4) = cstarr4
        newvar.outil.s = 1.0E+100
        newvar.outil.f = 10000000000.0#
        newvar.outil.rot = 1.0E+100
        newvar.outil.couple = 0
        newvar.outil.corrd = 40
        newvar.cycle.Zaf = 1.0E+100
        newvar.ptc.at = 0
        newvar.plunge = 0
        newvar.cldx = 1
        newvar.clex = 1
        newvar.rotdx = 1.0E+100
        newvar.rotex = 1.0E+100
        newvar.defaultex = 1.0E+100
        newvar.g682auto = 0
        newvar.g682m = 69
        newvar.g682x = 0
        newvar.g682y = 0
        newvar.g682z = 0
        newvar.g434etat = 0
        newvar.lintol = 0
        newvar.rotetat = 0

        sortie.cetat = 0


        sortie.chaine = ""
        sortie.Erreur = ""



        Dim saisie As String
        Dim buffer2 As String
        Dim chaine1 As String
        Dim chaine2 As String
        Dim concat As Short
        Dim compteur As Double
        Dim num1 As Short
        Dim i_outil_suivant As Short
        Dim ch1 As String
        Dim total As Integer
        total = 0


        newvar.etat = 0

        Dim liste_outils(1999) As Integer
        Dim i1 As Short
        i1 = 1



        Dim fichier_entree0 As Short
        fichier_entree0 = FreeFile()

        FileOpen(fichier_entree0, urlaptsource, OpenMode.Input)



        Do While Not EOF(fichier_entree0)


            saisie = LineInput(fichier_entree0)

            total = total + 1
            chaine1 = saisie


            If InStr(chaine1, "LOADTL") = 1 Then

                chaine1 = Mid(saisie, InStr(saisie, "/") + 1)

                If InStr(chaine1, ",") > 0 Then
                    chaine2 = Mid(chaine1, 1, InStr(chaine1, ","))
                Else
                    chaine2 = chaine1
                End If

                liste_outils(i1) = CInt(Fix(Val(chaine2)))

                If (i1 > 1) And (liste_outils(i1) = liste_outils(i1 - 1)) Then
                    i1 = i1 - 1
                End If

                i1 = i1 + 1
            End If

        Loop

        liste_outils(i1) = liste_outils(1)

        FileClose(fichier_entree0)



        i_outil_suivant = 2
        Dim ligne As Integer
        ligne = 0
        concat = 0
        boucle = 1
        passage = 0





        Dim fichier_entree As Short
        fichier_entree = FreeFile()

        FileOpen(fichier_entree, urlaptsource, OpenMode.Input)




        Dim Fichier0 As Integer
        Do While Not EOF(fichier_entree)


            If boucle = 1 Then
                saisie = LineInput(fichier_entree)
            Else
                saisie = buffer
                passage = 1
            End If



            compteur = compteur + 1

            If CInt(compteur / 100) <> ligne Then
                ligne = CInt(compteur / 100)
                pp_saisie.Label1.Text = Str(ligne * 100) & "  lignes traitees sur " & Str(total)
                System.Windows.Forms.Application.DoEvents()
            End If



            If InStr(saisie, "$$") > 0 Then
                saisie = "rien"
                newvar.etat = 0
            Else
                buffer2 = saisie
            End If


            num1 = Len(saisie)



            If InStr(saisie, "$") > 0 Then
                If concat = 0 Then
                    buffer = Mid(saisie, 1, InStr(saisie, "$") - 1)
                    concat = 1
                Else
                    buffer = buffer & Mid(saisie, 1, InStr(saisie, "$") - 1)
                End If
            Else
                If concat = 0 Then
                    buffer = saisie
                Else
                    buffer = buffer & saisie
                    concat = 0
                End If
            End If




            If concat = 0 Then

                newvar.etat = 0

                If InStr(buffer, "PARTNO") = 1 Then

                    ch0 = UCase(Mid(buffer, 8))
                    fichier_sortie_principal = ""

                    For i1 = 1 To Len(ch0)
                        num1 = Asc(Mid(ch0, i1, 1))
                        If num1 >= 48 And num1 <= 57 Then
                            fichier_sortie_principal = fichier_sortie_principal & Chr(num1)
                        End If
                    Next

                    If Val(fichier_sortie_principal) = 0 Or Val(fichier_sortie_principal) > 9999 Then
                        fichier_sortie_principal = "0001"
                        MsgBox("PARTNO incorrect, sortie renomme en 0001 ")
                    End If

                    sortie.chaine = "%O" & Mid(Str(Val(fichier_sortie_principal) + 10000), 3)
                    fichier_sortie = fichier_sortie_principal
                    newvar.etat = 1

                    If PresenceFichier(path & fichier_sortie & ".tap") <> False Then
                        fs = CreateObject("Scripting.FileSystemObject")
                        f = fs.GetFile(path & fichier_sortie & ".tap")
                        f.Delete()
                    End If


                    Fichier0 = FreeFile()
                    FileOpen(Fichier0, path & fichier_sortie & ".tap", OpenMode.Append)

                    pp_saisie.Label2.Text = fichier_sortie & ".tap"
                    System.Windows.Forms.Application.DoEvents()

                    fichier_sortie_etat = 0

                End If





                If InStr(buffer, "SEQNO") = 1 Then
                    If InStr(buffer, "OFF") > 0 Then
                        numeroBloc = -1
                    Else
                        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
                        numeroBloc = Math.Abs(Val(Mid(chaine1, 1, InStr(chaine1, ",") - 1)))
                        chaine1 = Mid(chaine1, InStr(chaine1, "INCR,") + 5)
                        increment = Math.Abs(Val(chaine1))
                    End If
                End If



                If InStr(buffer, "PPRINT") = 1 Then

                    chaine1 = Mid(buffer, 7)
                    chaine1 = StrConv(chaine1, VbStrConv.Uppercase)
                    chaine2 = "("
                    chaine2 = chaine2 & chaine1
                    chaine2 = chaine2 & ")"
                    sortie.chaine = chaine2
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "INSERT") = 1 Then

                    chaine2 = Mid(buffer, 8)
                    chaine2 = chaine2
                    sortie.chaine = chaine2
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "PIVOTZ") = 1 Then

                    If InStr(buffer, "OFF") > 0 Or InStr(buffer, "AUTO") > 0 Then
                    Else
                        Call word_pivotz()
                        oldvar.px = newvar.px
                        oldvar.py = newvar.py
                        oldvar.pz = newvar.pz
                    End If

                End If





                If InStr(buffer, "DEFSUB") = 1 Then

                    If fichier_sortie_etat = 0 Then

                        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
                        chaine2 = Str(10000 + Val(chaine1))
                        chaine2 = Mid(chaine2, 3)
                        fichier_sortie = fichier_sortie_principal & "S" & chaine2

                        If PresenceFichier(path & fichier_sortie & ".tap") <> False Then
                            fs = CreateObject("Scripting.FileSystemObject")
                            f = fs.GetFile(path & fichier_sortie & ".tap")
                            f.Delete()
                        End If

                        FileClose(Fichier0)

                        Fichier0 = FreeFile()
                        FileOpen(Fichier0, path & fichier_sortie & ".tap", OpenMode.Append)

                        pp_saisie.Label2.Text = fichier_sortie & ".tap"
                        System.Windows.Forms.Application.DoEvents()

                        sortie.chaine = "%O" & chaine2
                        newvar.etat = 1
                        fichier_sortie_etat = 1
                    End If

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "ENDSUB") = 1 Then

                    If fichier_sortie_etat = 1 Then
                        newvar.etat = 0
                        PrintLine(Fichier0, numN() & " M99" & vbLf & "%" & vbLf)
                        FileClose(Fichier0)

                        fichier_sortie_etat = 0
                        fichier_sortie = fichier_sortie_principal

                        Fichier0 = FreeFile()
                        FileOpen(Fichier0, path & fichier_sortie & ".tap", OpenMode.Append)

                        pp_saisie.Label2.Text = fichier_sortie & ".tap"
                        System.Windows.Forms.Application.DoEvents()

                    End If

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "CALSUB") = 1 Then

                    chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
                    chaine2 = Str(10000 + Val(chaine1))
                    chaine2 = Mid(chaine2, 3)

                    sortie.chaine = numN() & " M98 P" & chaine2
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If






                If InStr(buffer, "CLAMP") = 1 Then

                    If InStr(buffer, "1") > 0 Then
                        If InStr(buffer, "OFF") > 0 Then
                            newvar.cldx = 0
                        Else
                            newvar.cldx = 1
                        End If
                    Else
                        If InStr(buffer, "2") > 0 Then
                            If InStr(buffer, "OFF") > 0 Then
                                newvar.clex = 0
                            Else
                                newvar.clex = 1
                            End If
                        Else
                            If InStr(buffer, "OFF") > 0 Then
                                newvar.cldx = 0
                                newvar.clex = 0
                            Else
                                newvar.cldx = 1
                                newvar.clex = 1
                            End If
                        End If
                    End If

                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If






                If InStr(buffer, "CUTTER") = 1 Then

                    newvar.outil.dia = Val(Mid(buffer, InStr(buffer, "/") + 1, InStr(buffer, ",")))
                    newvar.etat = 0

                End If





                If InStr(buffer, "LOADTL") = 1 Then

                    newvar.outil.ts = liste_outils(i_outil_suivant)
                    Call word_loadtl()
                    i_outil_suivant = i_outil_suivant + 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "COOLNT") = 1 Then

                    If InStr(buffer, "FLOOD") > 0 Then
                        newvar.outil.arr = 1
                    End If

                    If InStr(buffer, "MIST") > 0 Then
                        If InStr(buffer, ",1") > 0 Or InStr(buffer, ",") = 0 Then
                            newvar.outil.arr = 2
                        End If
                        If InStr(buffer, ",2") > 0 Then
                            newvar.outil.arr = 3
                        End If
                        If InStr(buffer, ",3") > 0 Then
                            newvar.outil.arr = 4
                        End If
                    End If

                    If InStr(buffer, "OFF") > 0 Then
                        newvar.outil.arr = 0

                        If newvar.outil.arr <> oldvar.outil.arr Then
                            sortie.chaine = cstarr0
                        Else
                            sortie.chaine = ""
                        End If

                        newvar.etat = 1
                    Else
                        newvar.etat = 0
                    End If

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "SPINDL") = 1 Then

                    Call word_spindl()

                    If sortie.cetat = 1 And newvar.outil.s <> oldvar.outil.s Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "COUPLE") = 1 Then

                    If InStr(buffer, "ON") > 0 Then

                        If InStr(buffer, "1") > 0 Then
                            newvar.outil.couple = 1
                        Else
                            newvar.outil.couple = 2
                        End If

                    Else

                        newvar.outil.couple = 0

                    End If

                    newvar.etat = 0

                    If sortie.cetat = 1 And newvar.outil.couple <> oldvar.outil.couple Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "FEDRAT") = 1 Then

                    Call word_fedrat()

                    If sortie.cetat = 1 And newvar.outil.Forigin <> oldvar.outil.Forigin Then
                        sortie.cetat = 2
                    End If

                End If






                If InStr(buffer, "RAPID") = 1 Then

                    If newvar.ga <> 80 Then
                        newvar.ga = 0
                    End If

                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "CUTCOM") = 1 Then

                    Call extract_cutcom()
                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "GOTO") = 1 Then

                    Call word_goto()

                End If





                If InStr(buffer, "INDIRV") > 0 Then

                    Call extract_indirv()
                    newvar.etat = 0

                End If






                If InStr(buffer, "CIRCLE") > 0 Or InStr(buffer, "CYLNDR") > 0 Then

                    If sortie.cetat = 10 Then
                        sortie.cetat = 2
                    Else
                        Call words_circle_cylndr()
                    End If

                End If





                If InStr(buffer, "HELICAL") > 0 Then

                    If sortie.cetat = 10 Then
                        sortie.cetat = 2
                    Else
                        Call word_helical()
                    End If

                End If




                If InStr(buffer, "MODE") = 1 Then

                    If InStr(buffer, "HIGH") > 0 Then
                        If InStr(buffer, "OFF") > 0 Then
                            newvar.high = 0
                            If newvar.high_etat = 1 Then
                                newvar.etat = 0
                            Else
                                sortie.chaine = cg51q0
                                newvar.etat = 1
                            End If
                        Else
                            ch1 = Mid(buffer, InStr(buffer, ",") + 1)
                            If InStr(ch1, ",") > 0 Then
                                ch1 = Mid(ch1, 1, InStr(ch1, ",") - 1)
                            End If
                            newvar.high = Val(ch1)
                            If InStr(buffer, "START") > 0 Then
                                newvar.high_etat = 1
                                newvar.etat = 0
                            Else
                                newvar.high_etat = 0
                            End If
                            If newvar.high >= 1 And newvar.high <= 10 And newvar.high_etat = 0 Then
                                sortie.chaine = cg51q1r & Mid(Str(newvar.high), 2)
                                newvar.etat = 1
                            End If
                        End If
                    End If

                    If InStr(buffer, "XYZ") = 0 And InStr(buffer, "HIGH") = 0 Then
                        If InStr(buffer, "OFF") > 0 Then
                            sortie.chaine = "G49G53Z0"
                            newvar.g434etat = 0
                            newvar.etat = 1
                        End If
                        If InStr(buffer, "ON") > 0 Then
                            newvar.gd = 43.4
                            oldvar.gd = 1.0E+100
                            oldvar.ga = 1.0E+100
                            oldvar.gc = 1.0E+100
                            oldvar.outil.f = 100000000
                            newvar.g434etat = 1
                            newvar.etat = 0
                        End If
                    End If

                End If





                If InStr(buffer, "REVERS") = 1 Then

                    If InStr(buffer, "OFF") > 0 Then
                        newvar.g682auto = 0
                        newvar.g682m = 69
                        newvar.g682x = 0
                        newvar.g682y = 0
                        newvar.g682z = 0
                        sortie.chaine = "G69"
                        oldvar.g682m = 69
                        newvar.etat = 1
                    Else
                        newvar.g682auto = 1
                        newvar.g682m = 68.2
                        newvar.etat = 0
                    End If

                End If




                If InStr(buffer, "TOOLNO") = 1 Then

                    If InStr(buffer, "RADIUS") > 0 Then
                        newvar.outil.d = CShort(Fix(Val(Mid(buffer, InStr(buffer, ",") + 1))))
                    Else
                        newvar.outil.h = CShort(Fix(Val(Mid(buffer, InStr(buffer, "/") + 1))))
                        oldvar.outil.corrh = -1
                    End If

                    newvar.etat = 0

                End If




                If InStr(buffer, "STOP") = 1 Then

                    sortie.chaine = cm0
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "OSTOP") = 1 Then

                    sortie.chaine = cm1
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "ROTABL") = 1 Then

                    chaine1 = Mid(buffer, InStr(buffer, "/") + 1)

                    If InStr(chaine1, "AAXIS") > 0 Then
                        chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)

                        If InStr(chaine1, ",") > 0 Then
                            chaine2 = Mid(chaine1, 1, InStr(chaine1, ","))
                        Else
                            chaine2 = chaine1
                        End If

                        newvar.rotdx = Val(chaine2)
                    End If

                    If InStr(chaine1, "CAXIS") > 0 Then

                        chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)

                        If InStr(chaine1, ",") > 0 Then
                            chaine2 = Mid(chaine1, 1, InStr(chaine1, ","))
                        Else
                            chaine2 = chaine1
                        End If

                        newvar.rotex = Val(chaine2)
                        newvar.ptf.ex = newvar.rotex

                    End If

                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "MOVETO") = 1 Then

                    Call word_moveto()

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "DELAY") = 1 Then

                    chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
                    sortie.chaine = "G4X" & chaine(Val(chaine1))
                    newvar.etat = 1

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If



                If InStr(buffer, "ORIGIN") = 1 Then

                    Call word_origin()

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If


                If InStr(buffer, "CYCLE/OFF") = 1 Then

                    newvar.ga = 1.0E+100
                    oldvar.ga = 1.0E+100
                    newvar.cycle.Gs = 999
                    sortie.chaine = numN() & cg80
                    oldvar.ptf.cx = newvar.cycle.Zaf
                    newvar.etat = 1

                End If


                If InStr(buffer, "LINTOL") = 1 Then

                    If InStr(buffer, "OFF") > 0 Then
                        newvar.lintol = 0
                    Else
                        newvar.lintol = Val(Mid(buffer, InStr(buffer, "/") + 1))
                    End If

                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If




                If InStr(buffer, "CYCLE/BRKCHP") = 1 Or InStr(buffer, "CYCLE/INVERS") = 1 Or InStr(buffer, "CYCLE/LOCK") = 1 Or InStr(buffer, "CYCLE/DRILL") = 1 Or InStr(buffer, "CYCLE/FACE") = 1 Or InStr(buffer, "CYCLE/DEEP") = 1 Or InStr(buffer, "CYCLE/TAP") = 1 Or InStr(buffer, "CYCLE/BORE") = 1 Or InStr(buffer, "CYCLE/REAM") = 1 Or InStr(buffer, "CYCLE/STEP") = 1 Or InStr(buffer, "CYCLE/MANUAL") = 1 Or InStr(buffer, "CYCLE/THRU") = 1 Then

                    oldvar.cycle.Gs = 999
                    Call word_cycle()
                    newvar.outil.Forigin = newvar.outil.f
                    oldvar.outil.f = -1
                    newvar.etat = 0

                    If sortie.cetat = 1 Then
                        sortie.cetat = 2
                    End If

                End If





                If InStr(buffer, "CATMAT") = 1 Then

                    Call word_catmat()

                    If newvar.g682auto = 1 Then
                        newvar.g682x = newvar.rotb(1, 4) + newvar.rota(1, 4)
                        newvar.g682y = newvar.rotb(2, 4) + newvar.rota(2, 4)
                        newvar.g682z = newvar.rotb(3, 4) + newvar.rota(3, 4)
                        oldvar.ptf.dx = 1.0E+100
                        oldvar.ptf.ex = 1.0E+100
                    End If

                    newvar.etat = 0

                End If





                If sortie.cetat = 2 And boucle = 1 Then

                    newvar = sortie.imanew1
                    oldvar = sortie.imaold1
                    newvar.etat = 1

                    Call spcircle()
                    boucle = -1
                    sortie.cetat = 0

                End If






                If newvar.etat = 1 Then

                    If fichier_sortie_etat <> -1 Then

                        If Len(sortie.Erreur) > 0 Then
                            PrintLine(Fichier0, sortie.Erreur)
                        End If

                        If Len(sortie.chaine) > 0 Then
                            PrintLine(Fichier0, sortie.chaine)
                        End If

                        sortie.chaine = ""
                        sortie.Erreur = ""

                    Else
                        FileClose(fichier_entree)
                        MsgBox("PARTNO non dfini !")
                        Exit Sub
                    End If

                End If


            End If



            If passage = 1 Then
                boucle = 1
                passage = 0
            End If


        Loop


        FileClose(fichier_entree)


        sortie.chaine = numN() & cstarr0 & vbLf

        If numeroBloc > 0 Then
            sortie.chaine = sortie.chaine & numN() & finligne1 & vbLf
        Else
            sortie.chaine = sortie.chaine & cstn & "9999" & finligne1 & vbLf
        End If
        sortie.chaine = sortie.chaine & numN() & finligne2 & vbLf
        sortie.chaine = sortie.chaine & numN() & finligne3 & vbLf
        If liste_outils(1) <> newvar.outil.tc Then
            sortie.chaine = sortie.chaine & numN() & cstt & Mid(Str(10000 + liste_outils(1)), 3) & cm6 & vbLf
        End If
        sortie.chaine = sortie.chaine & numN() & finligne4 & vbLf & "%" & vbLf


        PrintLine(Fichier0, sortie.chaine)


        FileClose(Fichier0)

        pp_saisie.Label1.Text = "fin traitement"



    End Sub










    Private Sub word_loadtl()


        Dim chaine1 As String
        Dim tc As String


        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
        If InStr(chaine1, ",") > 0 Then
            chaine1 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            newvar.outil.tc = Val(chaine1)
        Else
            newvar.outil.tc = Val(chaine1)
        End If


        sortie.chaine = ""


        If newvar.outil.tc <> oldvar.outil.tc Then

            If oldvar.outil.tc = 1.0E+100 Then
                sortie.chaine = sortie.chaine & numN() & debutligne1 & vbLf
                sortie.chaine = sortie.chaine & numN() & debutligne2 & vbLf
                sortie.chaine = sortie.chaine & numN() & debutligne3 & vbLf
            End If

            If oldvar.g682m = 68.2 Then
                sortie.chaine = numN() & cg69 & vbLf
                If newvar.high_etat = 1 Then
                    sortie.chaine = sortie.chaine & numN() & cg51q0 & vbLf
                End If
            End If
            If numeroBloc > 0 Then
                sortie.chaine = sortie.chaine & numN()
            Else
                sortie.chaine = sortie.chaine & cstn
                chaine1 = Str(10000 + newvar.outil.tc)
                sortie.chaine = sortie.chaine & Mid(chaine1, 3)
            End If
            sortie.chaine = sortie.chaine & retourChangtOutil & vbLf

            sortie.chaine = sortie.chaine & numN() & cm1 & vbLf & numN() & cstt
            tc = Str(10000 + newvar.outil.tc)
            tc = Mid(tc, 3)
            sortie.chaine = sortie.chaine & tc & cm6
            If newvar.outil.tc <> newvar.outil.ts Then
                chaine1 = Str(newvar.outil.ts + 10000)
                chaine1 = Mid(chaine1, 3)
                sortie.chaine = sortie.chaine & vbLf & numN() & cstt & chaine1
            End If



            oldvar.ptf = newvar.ptf
            oldvar.outil = newvar.outil
            oldvar.cycle = newvar.cycle
            oldvar.ga = newvar.ga
            oldvar.gb = newvar.gb
            oldvar.gc = newvar.gc
            oldvar.gd = newvar.gd
            oldvar.ge = newvar.ge


            newvar.ptf.ax = 1.0E+100
            newvar.ptf.bx = 1.0E+100
            newvar.ptf.cx = 1.0E+100
            newvar.ptf.dx = 0
            newvar.ptf.ex = 0
            newvar.g682m = 69

            newvar.ga = 1.0E+100
            newvar.outil.s = -10
            newvar.outil.rot = 3
            newvar.outil.h = newvar.outil.tc
            newvar.outil.corrh = 43
            newvar.outil.d = newvar.outil.tc




            oldvar.outil.tc = newvar.outil.tc
            oldvar.outil.ts = newvar.outil.ts
            oldvar.outil.h = 1.0E+100
            oldvar.outil.d = 1.0E+100
            oldvar.outil.s = 0
            oldvar.outil.arr = 0
            oldvar.cycle.Zaf = 1.0E+100
            oldvar.ga = 1.0E+100
            oldvar.gb = 1.0E+100
            oldvar.gc = 1.0E+100
            oldvar.ge = 9999
            oldvar.ptf.ax = 1.0E+100
            oldvar.ptf.bx = 1.0E+100
            oldvar.ptf.cx = 1.0E+100
            oldvar.ptf.dx = 1.0E+100
            oldvar.ptf.ex = 1.0E+100
            oldvar.cldx = 1
            oldvar.clex = 1
            oldvar.g682m = 69
        End If

        If newvar.g682auto = 1 Then
            newvar.g682m = 68.2
        End If
        oldvar.outil.f = -1
        If newvar.defaultex <> 1.0E+100 Then
            oldvar.ptf.ex = 1.0E+100
        End If

        newvar.etat = 1

    End Sub








    Private Function chaine(ByVal d As Double) As String

        Dim s0 As String
        s0 = ""
        Dim A As Double
        A = d

        If Math.Abs(A) < 0.001 Then
            A = 0
        End If



        s0 = Str(CDbl(FormatNumber(A, 3)))

        If A >= 0 Then
            s0 = Mid(s0, 2)
        End If

        If InStr(s0, ".") = 0 Then
            s0 = s0 & "."
        End If

        chaine = s0

    End Function






    Private Sub word_goto()

        Dim chaine2 As String
        Dim chaineX As String
        Dim chaineY As String
        Dim chaineZ As String
        Dim chaineI As String
        Dim chaineJ As String
        Dim chaineK As String



        chaine2 = Mid(buffer, InStr(buffer, "/") + 1)
        chaineX = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.x = Val(chaineX)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineY = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.y = Val(chaineY)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineZ = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.z = Val(chaineZ)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineI = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.i = Val(chaineI)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineJ = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.j = Val(chaineJ)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        If InStr(chaine2, "PT") > 0 Then
            chaineK = Mid(chaine2, 1, InStr(chaine2, "PT") - 1)
        Else
            chaineK = chaine2
        End If
        ptd.k = Val(chaineK)



        ptf = CalculPointFinal(ptd)

        If Val(chaine(ptf.ax)) = Val(chaine(oldvar.ptf.ax)) And Val(chaine(ptf.bx)) = Val(chaine(oldvar.ptf.bx)) And Val(chaine(ptf.cx)) = Val(chaine(oldvar.ptf.cx)) And Val(chaine(ptf.dx)) = Val(chaine(oldvar.ptf.dx)) And Val(chaine(ptf.ex)) = Val(chaine(oldvar.ptf.ex)) Then

            '            MsgBox ("nul")


        Else


            If sortie.cetat = 1 Then
                sortie.cetat = 2
            Else

                newvar.ptf = ptf
                newvar.ptd = ptd
                newvar.rotdx = 1.0E+100
                newvar.rotex = 1.0E+100


                If (newvar.ga <> 0) And (newvar.ga <> 73) And (newvar.ga <> 74) And (newvar.ga <> 76) And (newvar.ga <> 81) And (newvar.ga <> 82) And (newvar.ga <> 83) And (newvar.ga <> 84) And (newvar.ga <> 85) And (newvar.ga <> 86) And (newvar.ga <> 87) And (newvar.ga <> 88) And (newvar.ga <> 89) Then

                    newvar.ga = 1

                End If


                If newvar.lintol > 0 And newvar.ga = 1 And oldvar.ptf.ax <> 1.0E+100 And oldvar.ptf.bx <> 1.0E+100 And oldvar.ptf.cx <> 1.0E+100 Then

                    Call linearisation()

                End If

                Call format_sortie()


                If newvar.ga = 0 Then

                    oldvar.outil = newvar.outil
                    oldvar.cycle = newvar.cycle
                    oldvar.ptf = newvar.ptf
                    oldvar.ga = newvar.ga
                    oldvar.gb = newvar.gb
                    oldvar.gc = newvar.gc
                    oldvar.gd = newvar.gd
                    oldvar.ge = newvar.ge

                    oldvar.cycle.P = -1
                    oldvar.cycle.Q = -1

                    newvar.ga = 1.0E+100

                Else

                    oldvar.outil = newvar.outil
                    oldvar.cycle = newvar.cycle
                    oldvar.ptf = newvar.ptf
                    oldvar.ga = newvar.ga
                    oldvar.gb = newvar.gb
                    oldvar.gc = newvar.gc
                    oldvar.gd = newvar.gd
                    oldvar.ge = newvar.ge

                End If

                newvar.etat = 1

            End If

        End If



    End Sub





    Private Function angle(ByVal i As Double, ByVal j As Double) As Double
        Dim i0 As Double
        Dim j0 As Double
        Dim angle_Renamed As Double
        angle_Renamed = 0
        Dim angleR As Double


        If i = 0 Then
            If j > 0 Then
                angle_Renamed = (pi / 2)
            End If
            If j < 0 Then
                angle_Renamed = 0 - (pi / 2)
            End If
            If j = 0 Then
                angle_Renamed = 0
            End If
        End If

        If i > 0 Then
            If j >= 0 Then
                If j <= i Then
                    angle_Renamed = Math.Atan(j / i)
                End If
                If j > i Then
                    angle_Renamed = (pi / 2) - Math.Atan(i / j)
                End If
            End If

            If j < 0 Then
                j0 = j * (0 - 1)
                If j0 <= i Then
                    angle_Renamed = 0 - Math.Atan(j0 / i)
                End If
                If j0 > i Then
                    angle_Renamed = 0 - (pi / 2) + Math.Atan(i / j0)
                End If
            End If
        End If

        If i < 0 Then
            i0 = i * (0 - 1)

            If j >= 0 Then
                If j <= i0 Then
                    angle_Renamed = pi - Math.Atan(j / i0)
                End If
                If j > i0 Then
                    angle_Renamed = (pi / 2) + Math.Atan(i0 / j)
                End If
            End If

            If j < 0 Then
                j0 = j * (0 - 1)
                If j0 <= i0 Then
                    angle_Renamed = 0 - pi + Math.Atan(j0 / i0)
                End If
                If j0 > i0 Then
                    angle_Renamed = 0 - (pi / 2) - Math.Atan(i0 / j0)
                End If
            End If
        End If

        angleR = angle_Renamed * (180 / pi)



        angle = angleR

    End Function





    Private Function CalculPointFinal(ByVal ptd As pointdebut) As pointfinal

        Dim k As Double
        Dim j As Double
        Dim i As Double
        Dim z As Double
        Dim y As Double
        Dim x As Double
        Dim k0 As Double
        Dim j0 As Double
        Dim i0 As Double
        Dim z0 As Double
        Dim y0 As Double
        Dim x0 As Double
        Dim s2 As Double
        Dim s1 As Double

        Dim r4axe1 As Double
        Dim r5axe1 As Double
        Dim tab1(6, 3) As Double
        Dim axy As Double
        Dim ay5z5 As Double
        Dim rij As Double
        Dim x5f As Double
        Dim y5f As Double
        Dim z5f As Double
        Dim ry5z5 As Double
        Dim rxy As Double
        Dim xf1 As Double
        Dim yf1 As Double
        Dim zf1 As Double
        s1 = 0
        s2 = 0
        Dim apypz, rpypz As Double
        Dim etat As Short
        etat = 0
        Dim i1 As Short
        i1 = 0
        Dim i2 As Short
        i2 = 0

        Dim ptflocal As pointfinal


        x0 = newvar.rotb(1, 1) * ptd.x + newvar.rotb(1, 2) * ptd.y + newvar.rotb(1, 3) * ptd.z + newvar.rotb(1, 4)
        y0 = newvar.rotb(2, 1) * ptd.x + newvar.rotb(2, 2) * ptd.y + newvar.rotb(2, 3) * ptd.z + newvar.rotb(2, 4)
        z0 = newvar.rotb(3, 1) * ptd.x + newvar.rotb(3, 2) * ptd.y + newvar.rotb(3, 3) * ptd.z + newvar.rotb(3, 4)
        i0 = newvar.rotb(1, 1) * ptd.i + newvar.rotb(1, 2) * ptd.j + newvar.rotb(1, 3) * ptd.k
        j0 = newvar.rotb(2, 1) * ptd.i + newvar.rotb(2, 2) * ptd.j + newvar.rotb(2, 3) * ptd.k
        k0 = newvar.rotb(3, 1) * ptd.i + newvar.rotb(3, 2) * ptd.j + newvar.rotb(3, 3) * ptd.k

        x0 = x0 + newvar.rota(1, 4) - newvar.g682x
        y0 = y0 + newvar.rota(2, 4) - newvar.g682y
        z0 = z0 + newvar.rota(3, 4) - newvar.g682z


        x = newvar.rota(1, 1) * x0 + newvar.rota(1, 2) * y0 + newvar.rota(1, 3) * z0
        y = newvar.rota(2, 1) * x0 + newvar.rota(2, 2) * y0 + newvar.rota(2, 3) * z0
        z = newvar.rota(3, 1) * x0 + newvar.rota(3, 2) * y0 + newvar.rota(3, 3) * z0
        i = newvar.rota(1, 1) * i0 + newvar.rota(1, 2) * j0 + newvar.rota(1, 3) * k0
        j = newvar.rota(2, 1) * i0 + newvar.rota(2, 2) * j0 + newvar.rota(2, 3) * k0
        k = newvar.rota(3, 1) * i0 + newvar.rota(3, 2) * j0 + newvar.rota(3, 3) * k0


        r5axe1 = angle(i, j)

        rij = Math.Sqrt((i * i) + (j * j))


        r4axe1 = angle(k, rij)


        If (r4axe1 <> 0) Then
            r5axe1 = 90 - r5axe1
        End If


        If r4axe1 = 0 Then
            r5axe1 = newvar.ptf.ex

            If ((newvar.defaultex <> 1.0E+100) And (oldvar.ptf.ex = 1.0E+100)) Or ((newvar.defaultex <> 1.0E+100) And (oldvar.ptf.dx <> 0)) Then
                r5axe1 = newvar.defaultex
                etat = 1
            End If


            If newvar.rotex <> 1.0E+100 Then
                r5axe1 = newvar.rotex
                etat = 1
            End If


        End If





        tab1(1, 2) = newvar.ptf.dx
        tab1(1, 3) = newvar.ptf.ex
        tab1(2, 2) = r4axe1
        tab1(2, 3) = r5axe1
        tab1(2, 1) = Math.Abs(tab1(2, 2) - tab1(1, 2)) + Math.Abs(tab1(2, 3) - tab1(1, 3))
        tab1(3, 2) = r4axe1
        tab1(3, 3) = r5axe1
        tab1(3, 1) = Math.Abs(tab1(3, 2) - tab1(1, 2)) + Math.Abs(tab1(3, 3) - tab1(1, 3))
        tab1(4, 2) = 0 - r4axe1
        tab1(4, 3) = r5axe1 - 180
        tab1(4, 1) = Math.Abs(tab1(4, 2) - tab1(1, 2)) + Math.Abs(tab1(4, 3) - tab1(1, 3))
        tab1(5, 2) = 0 - r4axe1
        tab1(5, 3) = r5axe1 + 180
        tab1(5, 1) = Math.Abs(tab1(5, 2) - tab1(1, 2)) + Math.Abs(tab1(5, 3) - tab1(1, 3))

        i2 = 5

        If (tab1(4, 2) < -30) Or (r4axe1 = 0) Then
            i2 = 2
        End If

        tab1(6, 2) = tab1(2, 2)
        tab1(6, 3) = tab1(2, 3)

        i1 = 2

        Do While i1 <= i2
            If tab1(2, 1) > tab1(i1, 1) Then
                tab1(6, 1) = tab1(i1, 1)
                tab1(6, 2) = tab1(i1, 2)
                tab1(6, 3) = tab1(i1, 3)
            End If
            i1 = i1 + 1
        Loop



        r4axe1 = tab1(6, 2)
        r5axe1 = tab1(6, 3)

        Do While (Math.Abs(r5axe1 - newvar.ptf.ex) > 180) And (etat = 0)
            If newvar.ptf.ex <= 0 Then
                If r5axe1 < newvar.ptf.ex Then
                    r5axe1 = r5axe1 + 360
                Else
                    r5axe1 = r5axe1 - 360
                End If
            End If
            If newvar.ptf.ex > 0 Then
                If r5axe1 < newvar.ptf.ex Then
                    r5axe1 = r5axe1 + 360
                Else
                    r5axe1 = r5axe1 - 360
                End If
            End If
        Loop

        rxy = Math.Sqrt(((x) * (x)) + ((y) * (y)))

        axy = angle(x, y)

        x5f = rxy * Math.Cos((axy + r5axe1) * pi / 180)
        y5f = rxy * Math.Sin((axy + r5axe1) * pi / 180)
        z5f = z


        ry5z5 = Math.Sqrt((y5f * y5f) + (z5f * z5f))
        ay5z5 = angle(z5f, y5f)

        rpypz = Math.Sqrt((newvar.py * newvar.py) + (newvar.pz * newvar.pz))
        apypz = angle(newvar.pz, newvar.py)


        yf1 = ((ry5z5) * Math.Sin((ay5z5 - r4axe1) * pi / 180)) + newvar.py - (rpypz * Math.Sin((apypz - r4axe1) * pi / 180))
        xf1 = x5f
        zf1 = ((ry5z5) * Math.Cos((ay5z5 - r4axe1) * pi / 180)) + newvar.pz - (rpypz * Math.Cos((apypz - r4axe1) * pi / 180))


        ptflocal.ax = xf1
        ptflocal.bx = yf1
        ptflocal.cx = zf1
        ptflocal.dx = r4axe1
        ptflocal.ex = r5axe1

        If newvar.g434etat = 1 Then
            ptflocal.ax = x
            ptflocal.bx = y
            ptflocal.cx = z
        End If


        CalculPointFinal = ptflocal
    End Function







    Private Sub calculavance(ByVal parg5 As String, ByVal sfed As String)
        Dim R2 As Double
        Dim R1 As Double
        Dim R As Double
        Dim A As Double
        Dim var1 As Double
        Dim z As Double
        Dim y As Double

        parg5 = ""

        If (newvar.outil.couple = 1) Or (newvar.outil.couple = 2) Then

            y = Math.Sqrt((newvar.ptc.ix * newvar.ptc.ix) + (newvar.ptc.jx * newvar.ptc.jx))

            If newvar.outil.corrd = 41 Then
                If newvar.ga = 3 Then
                    newvar.outil.f = newvar.outil.Forigin * y / (y + (newvar.outil.dia / 2))
                    If CShort(Fix(newvar.outil.f)) = 0 Then
                        newvar.outil.f = 1
                    End If
                End If
                If newvar.ga = 2 Then
                    z = y - (newvar.outil.dia / 2)
                    If z = 0 Then
                        newvar.outil.f = newvar.outil.Forigin * 2
                    Else
                        newvar.outil.f = newvar.outil.Forigin * y / (y - (newvar.outil.dia / 2))
                        If newvar.outil.f > (newvar.outil.Forigin * 2) Then
                            newvar.outil.f = newvar.outil.Forigin * 2
                        End If
                    End If
                    If newvar.outil.couple = 2 Then
                        newvar.outil.f = newvar.outil.Forigin
                    End If
                End If
            End If

            If newvar.outil.corrd = 42 Then
                If newvar.ga = 3 Then
                    z = y - (newvar.outil.dia / 2)
                    If z = 0 Then
                        newvar.outil.f = newvar.outil.Forigin * 2
                    Else
                        newvar.outil.f = newvar.outil.Forigin * y / (y - (newvar.outil.dia / 2))
                        If newvar.outil.f > (newvar.outil.Forigin * 2) Then
                            newvar.outil.f = newvar.outil.Forigin * 2
                        End If
                    End If

                    If newvar.outil.couple = 2 Then
                        newvar.outil.f = newvar.outil.Forigin
                    End If
                End If
                If newvar.ga = 2 Then
                    newvar.outil.f = newvar.outil.Forigin * y / (y + (newvar.outil.dia / 2))
                    If CShort(Fix(newvar.outil.f)) = 0 Then
                        newvar.outil.f = 1
                    End If
                End If
            End If

            If newvar.outil.corrd = 40 Or newvar.ga = 1 Then
                newvar.outil.f = newvar.outil.Forigin
            End If

        End If



        If newvar.outil.couple = 0 Then
            newvar.outil.f = newvar.outil.Forigin
        End If



        If (newvar.finvers = 1) And (newvar.ga = 1) Then

            var1 = Val(chaine(Math.Sqrt((newvar.ptd.x - oldvar.ptd.x) * (newvar.ptd.x - oldvar.ptd.x)) + ((newvar.ptd.y - oldvar.ptd.y) * (newvar.ptd.y - oldvar.ptd.y)) + ((newvar.ptd.z - oldvar.ptd.z) * (newvar.ptd.z - oldvar.ptd.z))))

            If var1 = 0 Then
                A = Math.Abs(Val(chaine(newvar.ptf.ex - oldvar.ptf.ex)))
                R = Val(chaine(Math.Sqrt((newvar.ptd.x * newvar.ptd.x) + (newvar.ptd.y * newvar.ptd.y))))
                If A > 0 Then
                    If R > 0 Then
                        newvar.outil.f = newvar.outil.Forigin / (R * (A / 180 * pi))
                        newvar.ge = 93
                    Else
                        newvar.outil.f = newvar.outil.Forigin
                        newvar.ge = 94
                    End If
                End If

            Else

                If newvar.lintol = 0 Then
                    A = Math.Abs(Val(chaine(newvar.ptf.ex - oldvar.ptf.ex)))
                    R1 = Val(chaine(Math.Sqrt((oldvar.ptd.x * oldvar.ptd.x) + (oldvar.ptd.y * oldvar.ptd.y))))
                    R2 = Val(chaine(Math.Sqrt((newvar.ptd.x * newvar.ptd.x) + (newvar.ptd.y * newvar.ptd.y))))
                    If A > 0 And Val(chaine(newvar.ptf.dx - oldvar.ptf.dx)) = 0 Then
                        If R1 = R2 And R1 > 0 Then
                            newvar.outil.f = newvar.outil.Forigin / Math.Sqrt(((R1 * (A / 180 * pi)) * (R1 * (A / 180 * pi))) + ((newvar.ptd.z - oldvar.ptd.z) * (newvar.ptd.z - oldvar.ptd.z)))
                            newvar.ge = 93
                        Else
                            newvar.outil.f = newvar.outil.Forigin
                            newvar.ge = 94
                        End If
                    Else
                        newvar.outil.f = newvar.outil.Forigin
                        newvar.ge = 94
                    End If
                Else
                    If (Math.Abs(Val(chaine(newvar.ptf.dx - oldvar.ptf.dx))) + Math.Abs(Val(chaine(newvar.ptf.ex - oldvar.ptf.ex)))) > 0 Then

                        newvar.outil.f = newvar.outil.Forigin / var1
                        newvar.ge = 93
                    Else
                        newvar.outil.f = newvar.outil.Forigin
                        newvar.ge = 94
                    End If
                End If
            End If

        End If


        If newvar.ge <> oldvar.ge Then
            If newvar.ge = 94 Then
                parg5 = cg94
            Else
                parg5 = cg93
            End If
        End If

        If CInt(newvar.outil.f) < Fmini Then
            newvar.outil.f = Fmini
        End If

        If CInt(newvar.outil.f) > Fmaxi Then
            newvar.outil.f = Fmaxi
        End If


        If CInt(newvar.outil.f) <> CInt(oldvar.outil.f) Then
            sfed = cavance & Mid(Str(CInt(newvar.outil.f)), 2)
        Else
            sfed = ""
        End If


        If (newvar.ge = 93) And (newvar.ga = 1) Then
            If newvar.outil.f <> oldvar.outil.f Then
                sfed = cavance & chaine(newvar.outil.f)
            Else
                sfed = ""
            End If
        End If



    End Sub








    Private Sub linearisation()

        Dim i1 As Double

        Dim ptdbck As pointdebut
        ptdbck = newvar.ptd
        Dim var1 As varclass
        var1.Initialize()
        Dim var2 As varclass
        var2.Initialize()
        Dim pA As pointdebut
        Dim pB As pointdebut
        Dim p1 As pointdebut
        Dim pfA As pointfinal
        Dim pfB As pointfinal
        Dim pf1 As pointfinal
        Dim pr1 As pointfinal
        Dim so As sortieclass
        Dim A1, BA, AA, E1, AB, BB, B1 As Double
        Dim linetat As Short

        oldvar.rota = newvar.rota
        oldvar.rotb = newvar.rotb
        var1 = newvar
        var2 = newvar
        pB = newvar.ptd
        linetat = 1
        i1 = 0

        While linetat > 0 And i1 < 1000

            pA = oldvar.ptd
            pfA = oldvar.ptf
            pfB = CalculPointFinal(pB)

            p1.x = pA.x + ((pB.x - pA.x) / 2)
            p1.y = pA.y + ((pB.y - pA.y) / 2)
            p1.z = pA.z + ((pB.z - pA.z) / 2)

            AA = 90 - pfA.ex
            BA = 90 - pfB.ex
            AB = pfA.dx
            BB = pfB.dx


            A1 = AA + ((BA - AA) / 2)
            B1 = AB + ((BB - AB) / 2)

            p1.i = Math.Sin(B1 * pi / 180) * Math.Cos(A1 * pi / 180)
            p1.j = Math.Sin(B1 * pi / 180) * Math.Sin(A1 * pi / 180)
            p1.k = Math.Cos(B1 * pi / 180)

            pf1 = CalculPointFinal(p1)


            pr1.ax = pfA.ax + ((pfB.ax - pfA.ax) / 2)
            pr1.bx = pfA.bx + ((pfB.bx - pfA.bx) / 2)
            pr1.cx = pfA.cx + ((pfB.cx - pfA.cx) / 2)


            E1 = Math.Sqrt(((pr1.ax - pf1.ax) * (pr1.ax - pf1.ax)) + ((pr1.bx - pf1.bx) * (pr1.bx - pf1.bx)) + ((pr1.cx - pf1.cx) * (pr1.cx - pf1.cx)))
            E1 = Val(chaine(E1))


            If E1 <= newvar.lintol Then

                If Val(chaine(pfB.ax)) = Val(chaine(newvar.ptf.ax)) And Val(chaine(pfB.bx)) = Val(chaine(newvar.ptf.bx)) And Val(chaine(pfB.cx)) = Val(chaine(newvar.ptf.cx)) And Val(chaine(pfB.dx)) = Val(chaine(newvar.ptf.dx)) And Val(chaine(pfB.ex)) = Val(chaine(newvar.ptf.ex)) Then
                    linetat = 0

                Else

                    var1.ptd = pB
                    var1.ptf = pfB
                    'Call format_sortie(oldvar, var1, so)
                    oldvar = var1
                    pB = newvar.ptd

                End If
            Else
                pB = p1
            End If

            i1 = i1 + 1
        End While


    End Sub








    Private Sub format_sortie()

        'MsgBox(" oldg1=  " + Str(oldvar.ga) + "  newg1= " + Str(newvar.ga))


        Dim var1 As Double
        Dim ncxold As Double
        Dim scxold As String
        Dim ncxnew As Double
        Dim scxnew As String
        Dim chaine1 As String
        Dim x As Double


        Dim ch1 As String
        ch1 = ""
        Dim varptf As pointfinal


        Dim parg1 As String
        parg1 = ""
        Dim parg2 As String
        parg2 = ""
        Dim parg3, parg4 As String
        parg3 = ""
        parg4 = ""
        Dim parg5 As String
        parg5 = ""
        Dim sarr As String
        sarr = ""

        Dim ax As String
        Dim bx As String
        Dim cx As String
        Dim dx As String
        Dim ex As String
        Dim yx As String
        Dim zx As String
        Dim ix As String
        Dim jx As String
        Dim ssrot As String
        Dim sh As String
        Dim scorrh As String
        scorrh = ""
        Dim sfed As String
        sfed = ""
        Dim sd As String
        Dim scorrd As String
        scorrd = ""
        Dim sab As String
        Dim sde As String
        Dim sGs As String
        sGs = ""
        Dim sZp As String
        Dim sZr As String
        Dim sQ As String
        Dim sP As String
        Dim scldx1 As String
        Dim scldx2 As String
        Dim sclex1 As String
        Dim sclex2 As String
        Dim sg682 As String
        Dim sg51on As String
        Dim sg51off As String
        sg682 = ""
        Dim sg682f As String
        sg682f = ""
        Dim y As Double
        Dim z As Double



        If newvar.outil.s <> oldvar.outil.s Then

            ssrot = cvitesse & Mid(Str(newvar.outil.s), 2)

            Select Case newvar.outil.rot
                Case 3
                    ssrot = ssrot & cm3
                Case 4
                    ssrot = ssrot & cm4
                Case 5
                    ssrot = cm5
            End Select

        Else
            ssrot = ""
        End If



        If (newvar.outil.h <> oldvar.outil.h) Or (newvar.gd <> oldvar.gd) Then

            sh = csth & Mid(Str(newvar.outil.h), 2)

            Select Case newvar.outil.corrh
                Case 43
                    scorrh = cg43
                Case 43.4
                    scorrh = cg434
                Case 49
                    scorrh = cg49
            End Select

        Else
            sh = ""
            scorrh = ""
        End If



        If newvar.outil.corrd <> oldvar.outil.corrd Then

            If newvar.outil.corrd <> 40 Then
                sd = cstd & Mid(Str(newvar.outil.d), 2)
            Else
                sd = ""
            End If

            Select Case newvar.outil.corrd
                Case 41
                    scorrd = cg41
                Case 42
                    scorrd = cg42
                Case 40
                    scorrd = cg40
            End Select

        Else
            sd = ""
            scorrd = ""
        End If






        If newvar.outil.arr <> oldvar.outil.arr Then

            sarr = newvar.outil.code_arr(newvar.outil.arr)

        Else
            sarr = ""
        End If




        If newvar.ga <> oldvar.ga Then

            Select Case newvar.ga
                Case 0
                    parg1 = cg0
                Case 1
                    parg1 = cg1
                Case 2
                    parg1 = cg2
                Case 3
                    parg1 = cg3
                Case 73
                    parg1 = cg73
                Case 74
                    parg1 = cg74
                Case 76
                    parg1 = cg76
                Case 81
                    parg1 = cg81
                Case 82
                    parg1 = cg82
                Case 83
                    parg1 = cg83
                Case 84
                    parg1 = cg84
                Case 85
                    parg1 = cg85
                Case 86
                    parg1 = cg86
                Case 87
                    parg1 = cg87
                Case 88
                    parg1 = cg88
                Case 89
                    parg1 = cg89
            End Select

        Else
            parg1 = ""
        End If



        If newvar.gb <> oldvar.gb Then

            If newvar.gb >= 101 And newvar.gb <= 148 Then
                parg2 = cg541p & Mid(Str(newvar.gb - 100), 2)
            Else

                Select Case newvar.gb
                    Case 52
                        parg2 = cg52
                    Case 53
                        parg2 = cg53
                    Case 54
                        parg2 = cg54
                    Case 55
                        parg2 = cg55
                    Case 56
                        parg2 = cg56
                    Case 57
                        parg2 = cg57
                    Case 58
                        parg2 = cg58
                    Case 59
                        parg2 = cg59
                End Select

            End If

        Else
            parg2 = ""
        End If



        If newvar.gc <> oldvar.gc Then

            parg3 = cg90

        Else
            parg3 = ""
        End If



        If newvar.gd <> oldvar.gd Then

            Select Case newvar.gd
                Case 43.4
                    parg4 = cg434
                Case 49
                    parg4 = cg49
            End Select

        Else
            parg4 = ""
        End If




        If newvar.ge <> oldvar.ge Then

            Select Case newvar.ge
                Case 93
                    parg5 = cg93
                Case 94
                    parg5 = cg94
            End Select

        Else
            parg5 = ""
        End If



        y = Val(chaine(newvar.ptf.dx))
        z = Val(chaine(oldvar.ptf.dx))

        If Math.Abs(newvar.ptf.dx) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE A )" & vbLf
        End If


        If (y <> z) Or (newvar.g434etat = 1) Then
            dx = csta & chaine(newvar.ptf.dx)
        Else
            dx = ""
        End If

        y = Val(chaine(newvar.ptf.ex))
        z = Val(chaine(oldvar.ptf.ex))

        If Math.Abs(newvar.ptf.ex) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE C )" & vbLf
        End If

        If (y <> z) Or (newvar.g434etat = 1) Then
            ex = cstc & chaine(newvar.ptf.ex)
        Else
            ex = ""
        End If


        scldx1 = ""
        scldx2 = ""
        sclex1 = ""
        sclex2 = ""



        If InStr(dx, csta) > 0 Then

            If newvar.cldx = 0 Then
                If oldvar.cldx = 1 Then
                    scldx1 = caunclamp
                Else
                    scldx1 = ""
                End If
                scldx2 = ""
            Else
                If oldvar.cldx = 1 Then
                    scldx1 = caunclamp
                Else
                    scldx1 = ""
                End If
                scldx2 = caclamp
            End If

        End If




        If InStr(ex, cstc) > 0 Then

            If newvar.clex = 0 Then
                If oldvar.clex = 1 Then
                    sclex1 = ccunclamp
                Else
                    sclex1 = ""
                End If
                sclex2 = ""
            Else
                If oldvar.clex = 1 Then
                    sclex1 = ccunclamp
                Else
                    sclex1 = ""
                End If
                sclex2 = ccclamp
            End If

        End If




        sg682f = ""

        ch1 = dx & ex

        sg51on = ""
        sg51off = ""



        If (Len(ch1) > 0) And (newvar.g682auto = 1) Then

            x = newvar.rota(1, 1) * newvar.g682x + newvar.rota(1, 2) * newvar.g682y + newvar.rota(1, 3) * newvar.g682z
            y = newvar.rota(2, 1) * newvar.g682x + newvar.rota(2, 2) * newvar.g682y + newvar.rota(2, 3) * newvar.g682z
            z = newvar.rota(3, 1) * newvar.g682x + newvar.rota(3, 2) * newvar.g682y + newvar.rota(3, 3) * newvar.g682z

            If newvar.high_etat = 1 Then
                sg51off = numN() & cg51q0
                sg51on = numN() & cg51q1r & Mid(Str(newvar.high), 2)
            End If

            If Val(chaine(newvar.ptf.dx)) = 0 And Val(chaine(newvar.ptf.ex)) = 0 Then
                chaine1 = numN() & cg682 & cstx & chaine(x) & csty & chaine(y) & cstz & chaine(z) & " I90. J0. K-90." & vbLf & numN() & cg531
                If Len(sg51on) > 1 Then
                    sg682 = sg51on & vbLf + chaine1
                Else
                    sg682 = chaine1
                End If
            Else
                chaine1 = numN() & cg682 & cstx & chaine(x) & csty & chaine(y) & cstz & chaine(z) & csti & chaine(newvar.ptf.ex) & cstj & chaine(newvar.ptf.dx) & " K0" & vbLf & numN() & cg531
                If Len(sg51on) > 1 Then
                    sg682 = sg51on & vbLf + chaine1
                Else
                    sg682 = chaine1
                End If
            End If

            If oldvar.g682m = 68.2 Then
                If Len(sg51off) > 1 Then
                    sg682f = numN() & cg69 & vbLf & sg51off
                Else
                    sg682f = numN() & cg69
                End If
            End If

            oldvar.ptf.ax = 1.0E+100
            oldvar.ptf.bx = 1.0E+100
            oldvar.ptf.cx = 1.0E+100

        End If



        y = Val(chaine(newvar.ptf.ax))
        z = Val(chaine(oldvar.ptf.ax))

        If Math.Abs(newvar.ptf.ax) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE X )"
        End If


        If (y <> z) Or (newvar.g434etat = 1) Then
            ax = cstx & chaine(newvar.ptf.ax)
        Else
            ax = ""
        End If

        y = Val(chaine(newvar.ptf.bx))
        z = Val(chaine(oldvar.ptf.bx))

        If Math.Abs(newvar.ptf.bx) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE Y )"
        End If

        If (y <> z) Or (newvar.g434etat = 1) Then
            bx = csty & chaine(newvar.ptf.bx)
        Else
            bx = ""
        End If

        y = Val(chaine(newvar.ptf.cx))
        z = Val(chaine(oldvar.ptf.cx))

        If Math.Abs(newvar.ptf.cx) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE Z )"
        End If

        If (y <> z) Or (newvar.g434etat = 1) Then
            cx = cstz & chaine(newvar.ptf.cx)
        Else
            cx = ""
        End If

        If Math.Abs(newvar.ptc.ix) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE I )"
        End If


        ix = csti & chaine(newvar.ptc.ix)


        If Math.Abs(newvar.ptc.jx) > 999999.999 Then
            sortie.Erreur = sortie.Erreur & vbLf & "M00( DEPASSEMENT COORDONNEE J )"
        End If

        jx = cstj & chaine(newvar.ptc.jx)




        Call calculavance(parg5, sfed)





        If ((newvar.ga = 0) Or (newvar.ga = 80)) And (newvar.g434etat = 0) Then


            If sarr <> "" Then
                sortie.chaine = sortie.chaine & numN() & sarr & vbLf
            End If

            scxnew = chaine(newvar.ptf.cx)
            ncxnew = Val(scxnew)

            scxold = chaine(oldvar.ptf.cx)
            ncxold = Val(scxold)

            sab = ax
            sab = sab & bx
            sab = sab & ssrot
            sde = dx & ex


            If ncxold > ncxnew Then
                If Len(sg682f) > 1 Then
                    sortie.chaine = sortie.chaine & sg682f & vbLf
                End If
                If Len(scldx1) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
                End If
                If Len(sclex1) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & sclex1 & vbLf
                End If
                If Len(sde) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3 & sde & vbLf
                End If
                If Len(sg682) > 1 Then
                    sortie.chaine = sortie.chaine & sg682 & vbLf
                End If
                If Len(scldx2) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & scldx2 & vbLf
                End If
                If Len(sclex2) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & sclex2 & vbLf
                End If
                If Len(sab) > 1 Then
                    If Len(sde) > 1 Then
                        sortie.chaine = sortie.chaine & numN() & sab & vbLf
                    Else
                        sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3 & sab & vbLf
                    End If
                End If
                sortie.chaine = sortie.chaine & numN() & scorrh
                sortie.chaine = sortie.chaine & cx
                sortie.chaine = sortie.chaine & sh
            End If



            If ncxnew > ncxold Then
                sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3
                sortie.chaine = sortie.chaine & scorrh
                sortie.chaine = sortie.chaine & cx
                sortie.chaine = sortie.chaine & sh
                If Len(sg682f) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & sg682f
                End If
                If Len(scldx1) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & scldx1
                End If
                If Len(sclex1) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & sclex1
                End If
                If Len(sde) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & sde
                End If
                If Len(sg682) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & sg682
                End If
                If Len(scldx2) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & scldx2
                End If
                If Len(sclex2) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & sclex2
                End If
                If Len(sab) > 1 Then
                    sortie.chaine = sortie.chaine & vbLf & numN() & sab
                End If
            End If



            If ncxnew = ncxold Then
                If Len(sg682f) > 1 Then
                    sortie.chaine = sortie.chaine & sg682f & vbLf
                End If
                If Len(scldx1) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
                End If
                If Len(sclex1) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & sclex1 & vbLf
                End If
                If Len(sde) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3 & sde & vbLf
                End If
                If Len(sg682) > 1 Then
                    sortie.chaine = sortie.chaine & sg682 & vbLf
                End If
                If Len(scldx2) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & scldx2 & vbLf
                End If
                If Len(sclex2) > 1 Then
                    sortie.chaine = sortie.chaine & numN() & sclex2 & vbLf
                End If
                If Len(sab) > 1 Then
                    If Len(sde) > 1 Then
                        sortie.chaine = sortie.chaine & numN() & sab
                    Else
                        sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3 & sab
                    End If
                End If
            End If

        End If




        If (newvar.ga = 0) And (newvar.g434etat = 1) Then

            If Len(ssrot) > 1 Then
                sortie.chaine = sortie.chaine & numN() & ssrot & vbLf
            End If
            If Len(scldx1) > 1 Then
                sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
            End If
            If Len(sclex1) > 1 Then
                sortie.chaine = sortie.chaine & numN() & sclex1 & vbLf
            End If
            sortie.chaine = sortie.chaine & numN() & parg1 & parg3 & parg4
            sortie.chaine = sortie.chaine & ax
            sortie.chaine = sortie.chaine & bx
            sortie.chaine = sortie.chaine & cx
            sortie.chaine = sortie.chaine & dx
            sortie.chaine = sortie.chaine & ex
            sortie.chaine = sortie.chaine & sh
            sortie.chaine = sortie.chaine & sd
            If Len(scldx2) > 1 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & scldx2
            End If
            If Len(sclex2) > 1 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & sclex2
            End If

        End If




        If (newvar.ga = 1) And (newvar.g434etat = 1) Then

            If Len(ssrot) > 0 Then
                sortie.chaine = sortie.chaine & numN() & ssrot & vbLf
            End If

            If Len(scldx1) > 0 Then
                sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
            End If
            If Len(sclex1) > 1 Then
                sortie.chaine = sortie.chaine & numN() & sclex1 & vbLf
            End If
            sortie.chaine = sortie.chaine & numN() & parg1 & parg3 & parg4
            sortie.chaine = sortie.chaine & ax
            sortie.chaine = sortie.chaine & bx
            sortie.chaine = sortie.chaine & cx
            sortie.chaine = sortie.chaine & dx
            sortie.chaine = sortie.chaine & ex
            sortie.chaine = sortie.chaine & sh
            sortie.chaine = sortie.chaine & sd
            sortie.chaine = sortie.chaine & sfed
            If Len(scldx2) > 0 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & scldx2
            End If
            If Len(sclex2) > 0 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & sclex2
            End If

        End If





        If (newvar.ga = 1) And (newvar.g434etat = 0) Then

            If Len(sortie.chaine) > 0 Then
                sortie.chaine = sortie.chaine & vbLf
            End If
            If Len(ssrot) > 0 Then
                sortie.chaine = sortie.chaine & numN() & ssrot & vbLf
            End If
            If Len(scldx1) > 0 Then
                sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
            End If
            If Len(sclex1) > 0 Then
                sortie.chaine = sortie.chaine & numN() & sclex1 & vbLf
            End If
            sortie.chaine = sortie.chaine & numN() & parg1 & parg2 & parg3 & parg5
            sortie.chaine = sortie.chaine & scorrd
            sortie.chaine = sortie.chaine & ax
            sortie.chaine = sortie.chaine & bx
            sortie.chaine = sortie.chaine & cx
            sortie.chaine = sortie.chaine & dx
            sortie.chaine = sortie.chaine & ex
            sortie.chaine = sortie.chaine & sd
            sortie.chaine = sortie.chaine & sfed
            If Len(scldx2) > 0 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & scldx2
            End If
            If Len(sclex2) > 0 Then
                sortie.chaine = sortie.chaine & vbLf & numN() & sclex2
            End If

        End If





        If newvar.ga = 2 Or newvar.ga = 3 Then

            If newvar.etat = 1 Then

                If Len(sortie.chaine) > 0 Then
                    sortie.chaine = sortie.chaine & vbLf
                End If
                If Len(ssrot) > 2 Then
                    sortie.chaine = sortie.chaine & numN() & ssrot & vbLf
                End If
                sortie.chaine = sortie.chaine & numN() & parg1 & parg3 & parg4 & parg5
                sortie.chaine = sortie.chaine & ax
                sortie.chaine = sortie.chaine & bx
                sortie.chaine = sortie.chaine & cx
                sortie.chaine = sortie.chaine & ix
                sortie.chaine = sortie.chaine & jx
                sortie.chaine = sortie.chaine & sfed
            End If

        End If







        If (newvar.ga = 73) Or (newvar.ga = 74) Or (newvar.ga = 76) Or (newvar.ga = 81) Or (newvar.ga = 82) _
        Or (newvar.ga = 83) Or (newvar.ga = 84) Or (newvar.ga = 85) Or (newvar.ga = 86) Or (newvar.ga = 87) _
        Or (newvar.ga = 88) Or (newvar.ga = 89) Then

            newvar.cycle.Zaf = Val(chaine(newvar.ptf.cx + newvar.cycle.Za))


            If Val(chaine(newvar.cycle.Zaf)) <> Val(chaine(oldvar.cycle.Zaf)) Then

                If Val(chaine(oldvar.ptf.cx)) <> Val(chaine(newvar.cycle.Zaf)) Then
                    oldvar.ptf.cx = oldvar.cycle.Zaf
                End If
                var1 = newvar.ga
                varptf = newvar.ptf
                If oldvar.ga <> 0 And oldvar.ga <> 1 And oldvar.ga <> 1.0E+100 Then
                    sortie.chaine = sortie.chaine & numN() & cg80 & vbLf
                End If
                newvar.ga = 0
                newvar.ptf.cx = newvar.cycle.Zaf
                Call format_sortie()
                oldvar.ptf = newvar.ptf
                newvar.ga = var1
                oldvar.ga = 1.0E+100
                newvar.ptf = varptf
                oldvar.cycle.Gs = 1.0E+100
                oldvar.cycle.Zaf = newvar.cycle.Zaf
                Call format_sortie()

            Else

                yx = chaine(newvar.ptf.cx + newvar.cycle.Zp)
                zx = chaine(oldvar.ptf.cx + oldvar.cycle.Zp)
                y = Val(yx)
                z = Val(zx)

                If y <> z Or Len(parg1) > 0 Then
                    sZp = cstz
                    sZp = sZp & yx
                Else
                    sZp = ""
                End If

                yx = chaine(newvar.ptf.cx + newvar.cycle.Zr)
                zx = chaine(oldvar.ptf.cx + oldvar.cycle.Zr)
                y = Val(yx)
                z = Val(zx)

                If y <> z Or Len(parg1) > 0 Then
                    sZr = cst_r
                    sZr = sZr & yx
                Else
                    sZr = ""
                End If


                sQ = ""

                If (newvar.ga = 73) Or (newvar.ga = 76) Or (newvar.ga = 83) Then

                    yx = chaine(newvar.cycle.Q)
                    zx = chaine(oldvar.cycle.Q)
                    y = Val(yx)
                    z = Val(zx)

                    If y <> z Or Len(parg1) > 0 Then
                        sQ = cstq
                        sQ = sQ + yx
                    End If

                End If


                sP = ""

                If (newvar.ga = 82) Or (newvar.ga = 89) Or (newvar.ga = 88) Then

                    yx = chaine(newvar.cycle.P)
                    zx = chaine(oldvar.cycle.P)
                    y = Val(yx)
                    z = Val(zx)

                    If y <> z Or Len(parg1) > 0 Then
                        sQ = cstp
                        sQ = sQ + yx
                    End If

                End If


                If newvar.cycle.Gs <> oldvar.cycle.Gs Then

                    Select Case newvar.cycle.Gs
                        Case 98
                            sGs = cg98
                        Case 99
                            sGs = cg99
                    End Select
                Else
                    sGs = ""
                End If

                If Len(sortie.chaine) > 0 Then
                    sortie.chaine = sortie.chaine & vbLf
                End If


                If Len(scldx1) > 0 Then
                    sortie.chaine = sortie.chaine & numN() & scldx1 & vbLf
                End If
                sortie.chaine = sortie.chaine & numN() & parg1 & parg5
                sortie.chaine = sortie.chaine & sGs
                sortie.chaine = sortie.chaine & ax
                sortie.chaine = sortie.chaine & bx
                sortie.chaine = sortie.chaine & dx
                sortie.chaine = sortie.chaine & sZp
                sortie.chaine = sortie.chaine + sQ
                sortie.chaine = sortie.chaine & sP
                sortie.chaine = sortie.chaine & sZr
                sortie.chaine = sortie.chaine & sfed
                If Len(scldx2) > 0 Then
                    sortie.chaine = sortie.chaine & scldx2
                End If

            End If
        End If


        If (InStr(sortie.chaine, parg1) > 0) And (Len(sortie.chaine) = (Len(parg1) + 1)) Then
            sortie.chaine = ""
        End If


    End Sub








    Private Sub extract_indirv()

        Dim chaine1 As String
        Dim chaineI As String
        Dim chaineJ As String
        Dim chaineK As String


        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)
        chaineI = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        ptd.x = Val(chaineI) + newvar.ptd.x

        chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
        chaineJ = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        ptd.y = Val(chaineJ) + newvar.ptd.y

        chaineK = Mid(chaine1, InStr(chaine1, ",") + 1)
        ptd.z = Val(chaineK) + newvar.ptd.z

        ptd.i = newvar.ptd.i
        ptd.j = newvar.ptd.j
        ptd.k = newvar.ptd.k

        newvar.ptfa = CalculPointFinal(ptd)


    End Sub






    Private Sub words_circle_cylndr()

        Dim PasPrecedent As Double
        Dim PasCourant As Double

        Dim chaine1 As String
        Dim chaineX As String
        Dim chaineY As String
        Dim chaineZ As String
        Dim A As Double
        Dim API As Double
        Dim APC As Double
        Dim AA As Double
        Dim AB As Double
        Dim ac As Double


        cercle.debut = newvar.ptf

        ptindirv = newvar.ptfa

        ptd = newvar.ptd




        If InStr(buffer, "CIRCLE") > 0 Then

            chaine1 = Mid(buffer, InStr(buffer, "CIRCLE/") + 7)
            chaineX = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.x = Val(chaineX)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineY = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.y = Val(chaineY)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineZ = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.z = Val(chaineZ)

            ptf = CalculPointFinal(ptd)

            cercle.axc = ptf.ax
            cercle.bxc = ptf.bx



            chaine1 = Mid(chaine1, InStr(chaine1, "LINE/") + 5)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)

            chaineX = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.x = Val(chaineX)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineY = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.y = Val(chaineY)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineZ = Mid(chaine1, 1, InStr(chaine1, ")") - 1)
            ptd.z = Val(chaineZ)

            cercle.fin = CalculPointFinal(ptd)


        Else

            chaine1 = Mid(buffer, InStr(buffer, "CYLNDR/") + 7)
            chaineX = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.x = Val(chaineX)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineY = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.y = Val(chaineY)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineZ = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.z = Val(chaineZ)

            ptf = CalculPointFinal(ptd)

            cercle.axc = ptf.ax
            cercle.bxc = ptf.bx


            chaine1 = Mid(chaine1, InStr(chaine1, "VECTOR/") + 7)
            chaine1 = Mid(chaine1, InStr(chaine1, "POINT/") + 6)
            chaine1 = Mid(chaine1, InStr(chaine1, "POINT/") + 6)

            chaineX = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.x = Val(chaineX)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineY = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            ptd.y = Val(chaineY)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineZ = Mid(chaine1, 1, InStr(chaine1, ")") - 1)
            ptd.z = Val(chaineZ)

            cercle.fin = CalculPointFinal(ptd)

        End If

        newvar.ptd = ptd


        API = angle(ptindirv.ax - cercle.debut.ax, ptindirv.bx - cercle.debut.bx)
        APC = angle(cercle.axc - cercle.debut.ax, cercle.bxc - cercle.debut.bx)

        A = APC - API

        If A > 180 Then
            A = A - 360
        End If

        If A < -180 Then
            A = A + 360
        End If


        If A > 0 Then
            cercle.g = 3
        Else
            cercle.g = 2
        End If





        AA = angle(cercle.axc - cercle.debut.ax, cercle.bxc - cercle.debut.bx)
        AB = angle(cercle.axc - cercle.fin.ax, cercle.bxc - cercle.fin.bx)

        If (cercle.g = 3) And (AB < AA) Then
            AB = 360 + AB
        End If
        If (cercle.g = 2) And (AB > AA) Then
            AB = AB - 360
        End If
        ac = AB - AA
        If ac < 0 Then
            ac = 0 - ac
        End If

        If Val(chaine(cercle.fin.ax)) = Val(chaine(cercle.debut.ax)) And Val(chaine(cercle.fin.bx)) = Val(chaine(cercle.debut.bx)) Then
            ac = 360
        End If


        PasCourant = 0
        If newvar.ptc.at = 0 Then
            PasPrecedent = 0
        Else
            PasPrecedent = Val(chaine((newvar.ptc.fin.cx - newvar.ptc.debut.cx) / newvar.ptc.at * 360))
        End If



        If cercle.g = oldvar.ga And sortie.cetat = 1 Then
            If (Val(chaine(cercle.axc)) = Val(chaine(newvar.ptc.axc))) And (Val(chaine(cercle.bxc)) = Val(chaine(newvar.ptc.bxc))) And PasPrecedent = PasCourant Then

                newvar.ptc.fin = cercle.fin
                newvar.ptc.at = newvar.ptc.at + ac

            Else
                newvar.etat = 1

                Call spcircle()

                newvar.ptc = cercle
                newvar.ptc.at = ac

            End If
        Else
            If (oldvar.ga = 2 Or oldvar.ga = 3) And sortie.cetat = 1 Then

                newvar.etat = 1

                Call spcircle()

            End If

            newvar.ptc = cercle
            newvar.ptc.at = ac
            newvar.ga = newvar.ptc.g
            newvar.gz = oldvar.ga

        End If


        newvar.etat = 0
        newvar.ptf = cercle.fin
        oldvar.ga = newvar.ga
        oldvar.ptf = newvar.ptf
        oldvar.outil.Forigin = newvar.outil.Forigin


        sortie.imanew1 = newvar
        sortie.imaold1 = oldvar
        sortie.cetat = 1



    End Sub






    Private Sub spcircle()
        Dim cxf As Double
        Dim atotal As Double


        If newvar.gz <> oldvar.ga Then
            oldvar.ga = 1.0E+100
        End If

        atotal = newvar.ptc.at
        cxf = newvar.ptc.fin.cx - newvar.ptc.debut.cx

        Do While newvar.ptc.at >= 360
            newvar.ptc.at = newvar.ptc.at - 360
            newvar.ptc.ix = newvar.ptc.axc - newvar.ptc.debut.ax
            newvar.ptc.jx = newvar.ptc.bxc - newvar.ptc.debut.bx
            newvar.ptf.ax = newvar.ptc.debut.ax
            newvar.ptf.bx = newvar.ptc.debut.bx

            newvar.ptf.cx = newvar.ptc.fin.cx - ((cxf / atotal) * newvar.ptc.at)

            newvar.ga = newvar.ptc.g

            oldvar.ptf.ax = 1.0E+100
            oldvar.ptf.bx = 1.0E+100
            oldvar.ptc.ix = 1.0E+100
            oldvar.ptc.jx = 1.0E+100
            oldvar.ptf.cx = newvar.ptc.debut.cx

            Call format_sortie()

            oldvar.ptf = newvar.ptf
            oldvar.ga = newvar.ga
            oldvar.gb = newvar.gb
            oldvar.gc = newvar.gc
            oldvar.gd = newvar.gd
            oldvar.ge = newvar.ge

            newvar.ptc.debut = newvar.ptf

        Loop


        If newvar.ptc.at > 0 And newvar.ptc.at < 360 Then
            newvar.ptc.at = 0

            newvar.ptf = newvar.ptc.fin

            newvar.ptc.ix = newvar.ptc.axc - newvar.ptc.debut.ax
            newvar.ptc.jx = newvar.ptc.bxc - newvar.ptc.debut.bx
            newvar.ga = newvar.ptc.g

            oldvar.ptf.ax = 1.0E+100
            oldvar.ptf.bx = 1.0E+100
            oldvar.ptc.ix = 1.0E+100
            oldvar.ptc.jx = 1.0E+100
            oldvar.ptf.cx = newvar.ptc.debut.cx

            Call format_sortie()

            oldvar.ptf = newvar.ptf
            oldvar.ga = newvar.ga
            oldvar.gb = newvar.gb
            oldvar.gc = newvar.gc
            oldvar.gd = newvar.gd
            oldvar.ge = newvar.ge

        End If


        newvar.gz = newvar.ga


    End Sub





    Private Sub word_helical()

        Dim chaine2 As String
        Dim chaineX As String
        Dim chaineY As String
        Dim chaineZ As String
        Dim A As Double
        Dim API As Double
        Dim APC As Double
        Dim ac As Double
        Dim PasCourant As Double
        Dim PasPrecedent As Double

        cercle.debut = newvar.ptf

        ptindirv = newvar.ptfa

        ptd = newvar.ptd


        chaine2 = Mid(buffer, InStr(buffer, "HELICAL/") + 9)
        chaineX = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.x = Val(chaineX)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineY = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.y = Val(chaineY)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineZ = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.z = Val(chaineZ)

        ptf = CalculPointFinal(ptd)

        cercle.axc = ptf.ax
        cercle.bxc = ptf.bx

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineX = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.x = Val(chaineX) + newvar.ptd.x

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineY = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.y = Val(chaineY) + newvar.ptd.y

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineZ = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.z = Val(chaineZ) + newvar.ptd.z


        ptindirv = CalculPointFinal(ptd)


        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)

        ac = Val(Mid(chaine2, 1, InStr(chaine2, ",") - 1))



        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)


        chaineX = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.x = Val(chaineX)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineY = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        ptd.y = Val(chaineY)

        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        chaineZ = chaine2
        ptd.z = Val(chaineZ)

        cercle.fin = CalculPointFinal(ptd)


        newvar.ptd = ptd

        API = angle(ptindirv.ax - cercle.debut.ax, ptindirv.bx - cercle.debut.bx)
        APC = angle(cercle.axc - cercle.debut.ax, cercle.bxc - cercle.debut.bx)

        A = APC - API

        If A > 180 Then
            A = A - 360
        End If

        If A < -180 Then
            A = A + 360
        End If

        If A > 0 Then
            cercle.g = 3
        Else
            cercle.g = 2
        End If


        PasCourant = Val(chaine((cercle.fin.cx - cercle.debut.cx) / ac * 360))
        If newvar.ptc.at = 0 Then
            PasPrecedent = 0
        Else
            PasPrecedent = Val(chaine((newvar.ptc.fin.cx - newvar.ptc.debut.cx) / newvar.ptc.at * 360))
        End If


        If cercle.g = oldvar.ga And sortie.cetat = 1 Then
            If (Val(chaine(cercle.axc)) = Val(chaine(newvar.ptc.axc))) And (Val(chaine(cercle.bxc)) = Val(chaine(newvar.ptc.bxc))) And PasCourant = PasPrecedent Then

                newvar.ptc.fin = cercle.fin
                newvar.ptc.at = newvar.ptc.at + ac

            Else
                newvar.etat = 1

                Call spcircle()

                newvar.ptc = cercle
                newvar.ptc.at = ac

            End If
        Else
            If (oldvar.ga = 2 Or oldvar.ga = 3) And sortie.cetat = 1 Then

                newvar.etat = 1

                Call spcircle()

            End If

            newvar.ptc = cercle
            newvar.ptc.at = ac
            newvar.ga = newvar.ptc.g
            newvar.gz = oldvar.ga

        End If


        newvar.etat = 0
        newvar.ptf = cercle.fin
        oldvar.ga = newvar.ga
        oldvar.ptf = newvar.ptf
        oldvar.outil.Forigin = newvar.outil.Forigin

        sortie.imanew1 = newvar
        sortie.imaold1 = oldvar
        sortie.cetat = 1


    End Sub









    Private Sub word_spindl()
        Dim chaine1 As String
        Dim chaine2 As String

        oldvar.outil.s = newvar.outil.s
        oldvar.outil.rot = newvar.outil.rot

        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)


        If InStr(buffer, "OFF") = 0 And InStr(buffer, "LOCK") = 0 And InStr(buffer, "ON") = 0 And InStr(buffer, "OUT") = 0 Then
            If InStr(chaine1, ",") > 0 Then
                chaine2 = Mid(chaine1, 1, InStr(chaine1, ","))
            Else
                chaine2 = chaine1
            End If
            newvar.outil.s = Val(chaine2)

            If InStr(buffer, "SFM") > 0 Then
                newvar.outil.s = 1000 * newvar.outil.s / (pi * newvar.outil.dia)
            End If

            newvar.outil.s = CInt(newvar.outil.s)

            If newvar.outil.s < Smini Then
                newvar.outil.s = Smini
            End If

            If newvar.outil.s > Smaxi Then
                newvar.outil.s = Smaxi
            End If

            If InStr(buffer, "CCLW") > 0 Then
                newvar.outil.rot = 4
            End If
            If InStr(buffer, ",CLW") > 0 Then
                newvar.outil.rot = 3
            End If
        End If

        newvar.etat = 0

        If InStr(buffer, "OFF") > 0 Then
            sortie.chaine = "M5"
            newvar.etat = 1
        End If

        If InStr(buffer, "LOCK") > 0 Then
            sortie.chaine = "M19"
            newvar.etat = 1
        End If

        If InStr(buffer, "ON") > 0 Then
            oldvar.outil.s = -1
            oldvar.outil.rot = -1
            newvar.etat = 0
        End If

        If InStr(buffer, "OUT") > 0 Then
            sortie.chaine = "S" & Mid(Str(newvar.outil.s), 2) & "M" & Mid(Str(newvar.outil.rot), 2)
            newvar.etat = 1
        End If

    End Sub







    Private Sub word_fedrat()
        Dim chaine2 As String

        If InStr(buffer, "INVERS") > 0 Then
            If InStr(buffer, "ON") > 0 Then
                newvar.finvers = 1
                newvar.ge = 93
            Else
                newvar.finvers = 0
                newvar.ge = 94
            End If
        Else
            chaine2 = Mid(buffer, InStr(buffer, "/") + 1, InStr(buffer, ","))
            newvar.outil.Forigin = Val(chaine2)
            newvar.outil.f = newvar.outil.Forigin
            If InStr(buffer, "MMPR") > 0 Then
                newvar.outil.Forigin = newvar.outil.s * newvar.outil.Forigin
                newvar.outil.f = newvar.outil.Forigin
            End If
        End If

        newvar.etat = 0

    End Sub




    Private Sub extract_cutcom()


        If InStr(buffer, "LEFT") > 0 Then
            newvar.outil.corrd = 41
        End If

        If InStr(buffer, "RIGHT") > 0 Then
            newvar.outil.corrd = 42
        End If

        If InStr(buffer, "OFF") > 0 Then
            newvar.outil.corrd = 40
        End If



    End Sub




    Private Sub word_cycle()

        Dim chaine2 As String
        Dim chaine3 As String
        Dim var1 As Double




        If InStr(buffer, "CYCLE/BRKCHP") > 0 Then
            newvar.ga = 73
        End If

        If InStr(buffer, "CYCLE/INVERS") > 0 Then
            newvar.ga = 74
        End If

        If InStr(buffer, "CYCLE/LOCK") > 0 Then
            newvar.ga = 76
        End If

        If InStr(buffer, "CYCLE/DRILL") > 0 Then
            newvar.ga = 81
        End If

        If InStr(buffer, "CYCLE/FACE") > 0 Then
            newvar.ga = 82
        End If

        If InStr(buffer, "CYCLE/DEEP") > 0 Then
            newvar.ga = 83
        End If

        If InStr(buffer, "CYCLE/TAP") > 0 Then
            newvar.ga = 84
        End If

        If InStr(buffer, "CYCLE/BORE") > 0 Then
            newvar.ga = 85
        End If

        If InStr(buffer, "CYCLE/REAM") > 0 Then
            newvar.ga = 86
        End If

        If InStr(buffer, "CYCLE/STEP") > 0 Then
            newvar.ga = 87
        End If

        If InStr(buffer, "CYCLE/MANUAL") > 0 Then
            newvar.ga = 88
        End If

        If InStr(buffer, "CYCLE/THRU") > 0 Then
            newvar.ga = 89
        End If

        chaine2 = Mid(buffer, InStr(buffer, ",") + 1)
        chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        newvar.cycle.Zp = Val(chaine3)

        If InStr(buffer, "CYCLE/BRKCHP") > 0 Or InStr(buffer, "CYCLE/LOCK") > 0 Or InStr(buffer, "CYCLE/DEEP") > 0 Then
            chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
            chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            newvar.cycle.Q = Val(chaine3)
        End If

        If InStr(chaine2, "MMPM") > 0 Then
            chaine2 = Mid(chaine2, InStr(chaine2, "MMPM") + 5)
            chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            newvar.outil.f = Val(chaine3)
        Else
            chaine2 = Mid(chaine2, InStr(chaine2, "MMPR") + 5)
            chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            newvar.outil.f = Val(chaine3) * newvar.outil.s
        End If
        chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
        If InStr(chaine2, ",") > 0 Then
            chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
        Else
            chaine3 = chaine2
        End If
        newvar.cycle.Zr = Val(chaine3)

        If InStr(buffer, "CYCLE/FACE") > 0 Or InStr(buffer, "CYCLE/MANUAL") > 0 Or InStr(buffer, "CYCLE/THRU") > 0 Then
            chaine2 = Mid(chaine2, InStr(chaine2, "DWELLV") + 7)
            chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            var1 = Val(chaine3)
            If var1 = 0 Then
                newvar.cycle.P = 0
            End If
            If var1 = 1 Then
                chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
                chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
                newvar.cycle.P = (Val(chaine3) / newvar.outil.s) * 60
            End If
            If var1 = 2 Then
                chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
                chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
                chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
                newvar.cycle.P = Val(chaine3)
            End If
        End If

        If InStr(chaine2, "POSZ") > 0 Then
            chaine2 = Mid(chaine2, InStr(chaine2, "POSZ") + 5)
            If InStr(chaine2, ",") > 0 Then
                chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            Else
                chaine3 = chaine2
            End If
            newvar.cycle.Za = Val(chaine3)
            If newvar.cycle.Za <= newvar.cycle.Zr Then
                newvar.cycle.Za = newvar.cycle.Zr
                newvar.cycle.Gs = 99
            Else
                newvar.cycle.Gs = 98
            End If
        Else
            newvar.cycle.Za = newvar.cycle.Zr
            newvar.cycle.Gs = 99
        End If

        If newvar.cycle.Za = 0 Then
            oldvar.ptf.cx = 1.0E+100
        End If



        newvar.etat = 0



    End Sub



    Private Sub word_pivotz()

        Dim chaine1 As String
        Dim chaine2 As String
        Dim chaineX As String
        Dim chaineY As String
        Dim chaineZ As String


        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)

        chaine2 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        If Val(chaine2) = 2 Then

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineX = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            newvar.px = Val(chaineX)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineY = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
            newvar.py = Val(chaineY)

            chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            chaineZ = chaine1
            newvar.pz = Val(chaineZ)
        Else
            newvar.px = 0
            newvar.py = 0
            newvar.pz = 0
        End If


        sortie.chaine = ""
        newvar.etat = 0


    End Sub





    Private Sub word_origin()
        Dim chaine2 As String
        Dim chaine3 As String

        newvar.xdec = 1.0E+100
        newvar.ydec = 1.0E+100
        newvar.zdec = 1.0E+100

        chaine2 = Mid(buffer, InStr(buffer, "/") + 1)

        If InStr(chaine2, "TYPE") > 0 Then
            chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
            If InStr(chaine2, ",") > 0 Then
                chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            Else
                chaine3 = chaine2
            End If
            If Val(chaine3) >= 0 And Val(chaine3) <= 6 Then
                newvar.gb = 53 + Val(chaine3)
            End If
            If Val(chaine3) >= 101 And Val(chaine3) <> 148 Then
                newvar.gb = Val(chaine3)
            End If

        Else
            If InStr(chaine2, ",") > 0 Then
                chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
            Else
                chaine3 = chaine2
            End If
            newvar.xdec = Val(chaine3)

            If InStr(chaine2, ",") > 0 Then
                chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
                If InStr(chaine2, ",") > 0 Then
                    chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
                Else
                    chaine3 = chaine2
                End If
                newvar.ydec = Val(chaine3)
            End If
            If InStr(chaine2, ",") > 0 Then
                chaine2 = Mid(chaine2, InStr(chaine2, ",") + 1)
                If InStr(chaine2, ",") > 0 Then
                    chaine3 = Mid(chaine2, 1, InStr(chaine2, ",") - 1)
                Else
                    chaine3 = chaine2
                End If
                newvar.zdec = Val(chaine3)
            End If

        End If




        newvar.etat = 0
        If (newvar.xdec <> 1.0E+100) And (newvar.ydec <> 1.0E+100) And (newvar.zdec <> 1.0E+100) Then
            sortie.chaine = cg52 & cstx & chaine(newvar.xdec) & csty & chaine(newvar.ydec) & cstz & chaine(newvar.zdec)
            newvar.etat = 1
        End If

        If (InStr(buffer, "OUT") > 0) And (newvar.gb <> 1.0E+100) Then
            If newvar.gb >= 53 And newvar.gb <= 59 Then
                sortie.chaine = "G" & Mid(Str(newvar.gb), 2)
            End If
            If newvar.gb >= 101 And newvar.gb <= 148 Then
                sortie.chaine = cg541p & Mid(Str(newvar.gb - 100), 2)
            End If

            oldvar.gb = newvar.gb
            newvar.etat = 1
        End If

    End Sub




    Private Sub word_moveto()


        Dim chaine1 As String


        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)

        If InStr(chaine1, "START") > 0 Then
            If InStr(chaine1, "OFF") > 0 Then
                newvar.defaultex = 1.0E+100
            Else

                If InStr(chaine1, "CAXIS") > 0 Then
                    If newvar.rotex <> 1.0E+100 Then

                        newvar.defaultex = newvar.rotex
                    Else
                        newvar.defaultex = 0
                    End If
                End If
            End If
            newvar.etat = 0


        End If


        If InStr(buffer, "OUT") > 0 Then
            If InStr(buffer, "AAXIS") > 0 Then

                oldvar.ptf.dx = 1.0E+100

                If newvar.rotdx <> 1.0E+100 Then

                    newvar.ptf.dx = newvar.rotdx
                End If
            End If

            If InStr(buffer, "CAXIS") > 0 Then

                If newvar.rotex <> 1.0E+100 Then

                    newvar.ptf.ex = newvar.rotex
                End If
            End If

            If InStr(chaine1, "XAXIS") > 0 Then

                oldvar.ptf.ax = 1.0E+100

            End If

            If InStr(chaine1, "YAXIS") > 0 Then

                oldvar.ptf.bx = 1.0E+100

            End If

            If InStr(chaine1, "ZAXIS") > 0 Then

                oldvar.ptf.cx = 1.0E+100

            End If


            If (newvar.ga <> 0) And (newvar.ga <> 73) And (newvar.ga <> 74) And (newvar.ga <> 76) And (newvar.ga <> 81) And (newvar.ga <> 82) And (newvar.ga <> 83) And (newvar.ga <> 84) And (newvar.ga <> 85) And (newvar.ga <> 86) And (newvar.ga <> 87) And (newvar.ga <> 88) And (newvar.ga <> 80) Then
                newvar.ga = 1
            End If
            oldvar.ga = 1.0E+100

            Call format_sortie()

            oldvar.ptf = newvar.ptf
            oldvar.outil.tc = newvar.outil.tc
            oldvar.outil.arr = newvar.outil.arr
            oldvar.ga = newvar.ga
            oldvar.gb = newvar.gb
            oldvar.gc = newvar.gc
            oldvar.gd = newvar.gd
            newvar.etat = 1
        End If


        If (InStr(buffer, "START") = 0) And (InStr(buffer, "OUT") = 0) Then
            If InStr(chaine1, "XAXIS") > 0 Then

                oldvar.ptf.ax = 1.0E+100

            End If
            If InStr(chaine1, "YAXIS") > 0 Then

                oldvar.ptf.bx = 1.0E+100

            End If
            If InStr(chaine1, "ZAXIS") > 0 Then

                oldvar.ptf.cx = 1.0E+100

            End If

            If InStr(chaine1, "AAXIS") > 0 Then

                oldvar.ptf.dx = 1.0E+100

            End If
            If InStr(chaine1, "CAXIS") > 0 Then

                oldvar.ptf.ex = 2.0E+120

            End If
            oldvar.ga = 1.0E+100
            newvar.etat = 0
        End If


    End Sub




    Private Sub word_catmat()
        Dim dam1 As Double
        Dim detA As Double

        Dim mat1(3, 4) As Double
        Dim mat2(3, 3) As Double
        Dim i1 As Short
        Dim j1 As Short
        Dim chaine1 As String
        Dim chaine2 As String


        chaine1 = Mid(buffer, InStr(buffer, "/") + 1)

        For i1 = 1 To 3
            For j1 = 1 To 3
                chaine2 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
                mat1(i1, j1) = Val(chaine2)
                chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)
            Next
        Next


        chaine2 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        mat1(1, 4) = Val(chaine2)
        chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)

        chaine2 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        mat1(2, 4) = Val(chaine2)
        chaine1 = Mid(chaine1, InStr(chaine1, ",") + 1)

        chaine2 = Mid(chaine1, 1, InStr(chaine1, ",") - 1)
        mat1(3, 4) = Val(chaine2)


        For i1 = 1 To 3
            For j1 = 1 To 3
                newvar.rotb(i1, j1) = mat1(i1, j1)
            Next
        Next

        newvar.rotb(1, 4) = mat1(1, 4)
        newvar.rotb(2, 4) = mat1(2, 4)
        newvar.rotb(3, 4) = mat1(3, 4)





        If newvar.rotetat = 0 Then

            detA = (mat1(1, 1) * mat1(2, 2) * mat1(3, 3)) + (mat1(1, 2) * mat1(2, 3) * mat1(3, 1)) + (mat1(1, 3) * mat1(2, 1) * mat1(3, 2))
            detA = detA - (mat1(1, 3) * mat1(2, 2) * mat1(3, 1)) - (mat1(2, 3) * mat1(3, 2) * mat1(1, 1)) - (mat1(3, 3) * mat1(1, 2) * mat1(2, 1))

            If detA <> 0 Then
                dam1 = 1 / detA

                mat2(1, 1) = dam1 * ((mat1(2, 2) * mat1(3, 3)) - (mat1(2, 3) * mat1(3, 2)))
                mat2(1, 2) = dam1 * ((mat1(1, 3) * mat1(3, 2)) - (mat1(1, 2) * mat1(3, 3)))
                mat2(1, 3) = dam1 * ((mat1(1, 2) * mat1(2, 3)) - (mat1(1, 3) * mat1(2, 2)))

                mat2(2, 1) = dam1 * ((mat1(2, 3) * mat1(3, 1)) - (mat1(2, 1) * mat1(3, 3)))
                mat2(2, 2) = dam1 * ((mat1(1, 1) * mat1(3, 3)) - (mat1(1, 3) * mat1(3, 1)))
                mat2(2, 3) = dam1 * ((mat1(1, 3) * mat1(2, 1)) - (mat1(1, 1) * mat1(2, 3)))

                mat2(3, 1) = dam1 * ((mat1(2, 1) * mat1(3, 2)) - (mat1(2, 2) * mat1(3, 1)))
                mat2(3, 2) = dam1 * ((mat1(1, 2) * mat1(3, 1)) - (mat1(1, 1) * mat1(3, 2)))
                mat2(3, 3) = dam1 * ((mat1(1, 1) * mat1(2, 2)) - (mat1(1, 2) * mat1(2, 1)))
            Else
                MsgBox("Determinant matrice est nul !!!  erreur ! ")
                Exit Sub
            End If

            For i1 = 1 To 3
                For j1 = 1 To 3
                    newvar.rota(i1, j1) = mat2(i1, j1)
                Next
            Next
            newvar.rota(1, 4) = -mat1(1, 4)
            newvar.rota(2, 4) = -mat1(2, 4)
            newvar.rota(3, 4) = -mat1(3, 4)
            newvar.rotetat = 1

        End If


    End Sub







    Private Function Asin(ByRef x As Double) As Double

        If x = 1 Then

            Asin = pi / 2

        ElseIf x = -1 Then

            Asin = -pi / 2

        Else

            Asin = Math.Atan(x / Math.Sqrt(-x * x + 1))

        End If


    End Function







    Private Function Atan2(ByRef y As Double, ByRef x As Double) As Double


        If x > 0 Then

            Atan2 = Math.Atan(y / x)

        ElseIf x < 0 Then

            Atan2 = Math.Sign(y) * (pi - Math.Atan(Math.Abs(y / x)))

        ElseIf y = 0 Then

            Atan2 = 0

        Else

            Atan2 = Math.Sign(y) * pi / 2

        End If


    End Function
End Module